//
//  AppDelegate.swift
//  EBV-IoT
//
//  Created by Milan Patel on 31/01/22.
//

import UIKit
import AppCenterCrashes
import IQKeyboardManagerSwift
import SideMenu
import AppCenter
import AppCenterCrashes
import SystemConfiguration

@main
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?
    var myNavigation : MyNavigationController?
    var rootViewController : UIViewController!
    var orientationLock = UIInterfaceOrientationMask.all
    var objhistoryvc : HistoryVC?
    var arr_History_Sensor : [[String:Any]] = []
    var arr_Color_Sensor : [[String:Any]] = []
    var isLoad : Bool = false
    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        // Override point for customization after application launch.
        
        IQKeyboardManager.shared.enable = true
        IQKeyboardManager.shared.shouldResignOnTouchOutside = true
        IQKeyboardManager.shared.shouldShowToolbarPlaceholder = false
        AppCenter.start(withAppSecret: Constant.AppCenter_SecretKey , services: [Crashes.self])
        
        let storyboard:UIStoryboard = UIStoryboard(name: Constant.StoryboardIdentifier.main, bundle: nil)
        myNavigation = storyboard.instantiateInitialViewController() as? MyNavigationController
        self.rootViewController = storyboard.instantiateViewController(withIdentifier: "SplashVC") as! SplashVC
        myNavigation?.viewControllers = [rootViewController]
        self.window?.rootViewController = myNavigation
        return true
    }
    
    func GotoLogin() {
        DispatchQueue.main.async {
            UserDefaultManager.shared[.email] =  nil
            UserDefaultManager.shared[.password] =  nil
            UserDefaultManager.shared[.basictoken] =  nil
            UserDefaultManager.shared[.accesstoken] =  nil
            UserDefaultManager.shared[.refreshtoken] =  nil
            UserDefaultManager.shared[.rootaccesstoken] =  nil
            UserDefaultManager.shared[.rootrefreshtoken] =  nil
            UserDefaultManager.shared[.accesstokenSubscription] =  nil
            UserDefaultManager.shared[.entityGuid] =  nil
            UserDefaultManager.shared[.templateGuid] =  nil
            UserDefaultManager.shared[.firstname]  = nil
            UserDefaultManager.shared[.lastname]  = nil
            UserDefaultManager.shared[.cpId]  = nil
            UserDefaultManager.shared[.isLogin] = nil
            UserDefaultManager.shared[.deviceAdded] = nil
            UserDefaultManager.shared[.rootemail] = nil
            UserDefaultManager.shared[.isRootLogin] = nil
            UserDefaultManager.shared[.rootemail] = nil
            UserDefaultManager.shared[.rootpass] = nil

            let mainStoryboard: UIStoryboard = UIStoryboard(name: Constant.StoryboardIdentifier.login,bundle: nil)
            let destViewController = mainStoryboard.instantiateViewController(withIdentifier: "LoginVC")
            self.myNavigation?.sideMenuController()?.setContentViewController(destViewController)
        }
    }
    
    func application(_ application: UIApplication, supportedInterfaceOrientationsFor window: UIWindow?) -> UIInterfaceOrientationMask {
        return self.orientationLock
    }
    
    func isConnectedToNetwork() -> Bool {

        var zeroAddress = sockaddr_in(sin_len: 0, sin_family: 0, sin_port: 0, sin_addr: in_addr(s_addr: 0), sin_zero: (0, 0, 0, 0, 0, 0, 0, 0))
        zeroAddress.sin_len = UInt8(MemoryLayout.size(ofValue: zeroAddress))
        zeroAddress.sin_family = sa_family_t(AF_INET)

        let defaultRouteReachability = withUnsafePointer(to: &zeroAddress) {
            $0.withMemoryRebound(to: sockaddr.self, capacity: 1) {zeroSockAddress in
                SCNetworkReachabilityCreateWithAddress(nil, zeroSockAddress)
            }
        }

        var flags: SCNetworkReachabilityFlags = SCNetworkReachabilityFlags(rawValue: 0)
        if SCNetworkReachabilityGetFlags(defaultRouteReachability!, &flags) == false {
            return false
        }

        /* Only Working for WIFI
        let isReachable = flags == .reachable
        let needsConnection = flags == .connectionRequired

        return isReachable && !needsConnection
        */

        // Working for Cellular and WIFI
        let isReachable = (flags.rawValue & UInt32(kSCNetworkFlagsReachable)) != 0
        let needsConnection = (flags.rawValue & UInt32(kSCNetworkFlagsConnectionRequired)) != 0
        let ret = (isReachable && !needsConnection)

        return ret
    }
}

