//
//  AlertConstant.swift
//  Procell
//
//  Created by Megha Salla on 01/11/21.

import UIKit

let APP_NAME = "EBV-IoT"

struct AlertConstant {
    
    static func showAlertMessage(_ controllerObj: UIViewController, Message:String) {
        DispatchQueue.main.async(execute: {
            let alertController = UIAlertController(title:APP_NAME, message: Message, preferredStyle: UIAlertController.Style.alert)
            alertController.view.tintColor = UIColor.black
            alertController.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: nil))
            controllerObj.present(alertController, animated: true, completion: nil)
        })
    }
    
    static func displayAlertMessage(viewController: UIViewController, strMessage: String) {
        DispatchQueue.main.async(execute: {
            let alertController = UIAlertController(title: APP_NAME , message:strMessage, preferredStyle: UIAlertController.Style.alert)
            alertController.view.tintColor = UIColor.black
            let okAction = UIAlertAction(title: "OK", style: UIAlertAction.Style.default) {
                (result : UIAlertAction) -> Void in
            }
            alertController.addAction(okAction)
            viewController.present(alertController, animated: true, completion: nil)
        })
    }
    
    static func displayAlertMessageWithBlock(viewController: UIViewController,
                                             strMessage:String,
                                             buttonTitle:String,
                                             handler: ((UIAlertAction) -> Swift.Void)? = nil) {
        DispatchQueue.main.async(execute: {
           let alertController = UIAlertController(title:APP_NAME ,message:strMessage, preferredStyle: UIAlertController.Style.alert)
            alertController.view.tintColor = UIColor.black
           let okAction = UIAlertAction(title: buttonTitle, style: UIAlertAction.Style.default) {
               (result : UIAlertAction) -> Void in
               handler?(result)
           }
           alertController.addAction(okAction)
           viewController.present(alertController, animated: true, completion: nil)
        })
    }
    
    static func displayAlertMessageWithTwoButtonBlock(viewController: UIViewController,
                                                      strMessage: String,
                                                      buttonTitle1: String,
                                                      buttonTitle2: String,
                                                      handler: ((UIAlertAction) -> Swift.Void)? = nil) {
        let alertController = UIAlertController(title: APP_NAME , message:strMessage, preferredStyle: UIAlertController.Style.alert)
        alertController.view.tintColor = UIColor.black
        let okAction = UIAlertAction(title: buttonTitle1, style: UIAlertAction.Style.default) {
            (result : UIAlertAction) -> Void in
            handler?(result)
        }
        let okAction2 = UIAlertAction(title: buttonTitle2, style: UIAlertAction.Style.default) {
            (result : UIAlertAction) -> Void in
            handler?(result)
        }
        alertController.addAction(okAction)
        alertController.addAction(okAction2)
        viewController.present(alertController, animated: true, completion: nil)
    }
    
    static func isValidEmail(_ email: String) -> Bool {
        let emailRegEx = "[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,64}"

        let emailPred = NSPredicate(format:"SELF MATCHES %@", emailRegEx)
        return emailPred.evaluate(with: email)
    }
    
    static func isValidPassword(_ password: String) -> Bool {
        let passRegEx = "^(?=.*[a-z])(?=.*[A-Z])(?=.*\\d)(?=.*[d$@$!%*?&#])[A-Za-z\\dd$@$!%*?&#]{8,}"

        let passPred = NSPredicate(format:"SELF MATCHES %@", passRegEx)
        return passPred.evaluate(with: password)
    }

}
