//
//  WebConstant.swift

import UIKit

struct WebConstant {
    
    // Here change tag Dev to QA while provide build for Testing
    static var BASE_URL_AUTHENTICATION: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetauth.iotconnect.io"
        case .qa:
            return "avnetauth.iotconnect.io"
        case .uat:
            return "avnetauth.iotconnect.io"
        case .prod:
            return "avnetauth.iotconnect.io"
        }
    }
    
    static var BASE_URL_COMPANY: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetcompany.iotconnect.io"
        case .qa:
            return "avnetcompany.iotconnect.io"
        case .uat:
            return "avnetcompany.iotconnect.io"
        case .prod:
            return "avnetcompany.iotconnect.io"
        }
    }
    
    static var BASE_URL_AUTHORIZE: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetauthorize.iotconnect.io"
        case .qa:
            return "avnetauthorize.iotconnect.io"
        case .uat:
            return "avnetauthorize.iotconnect.io"
        case .prod:
            return "avnetauthorize.iotconnect.io"
        }
    }

    
    
    static var BASE_URL_DEVICE: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetdevice.iotconnect.io"
        case .qa:
            return "avnetdevice.iotconnect.io"
        case .uat:
            return "avnetdevice.iotconnect.io"
        case .prod:
            return "avnetdevice.iotconnect.io"
        }
    }
    
    static var BASE_URL_USER: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetuser.iotconnect.io"
        case .qa:
            return "avnetuser.iotconnect.io"
        case .uat:
            return "avnetuser.iotconnect.io"
        case .prod:
            return "avnetuser.iotconnect.io"
        }
    }
    
    static var BASE_URL_TELEMETRY: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnettelemetry.iotconnect.io"
        case .qa:
            return "avnettelemetry.iotconnect.io"
        case .uat:
            return "avnettelemetry.iotconnect.io"
        case .prod:
            return "avnettelemetry.iotconnect.io"
        }
    }
    
    static var BASE_URL_SIGNALR: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "https://avnetsignalr.iotconnect.io"
        case .qa:
            return "https://avnetsignalr.iotconnect.io"
        case .uat:
            return "https://avnetsignalr.iotconnect.io"
        case .prod:
            return "https://avnetsignalr.iotconnect.io"
        }
    }
    
    static var BASE_URL_SUBSCRIPTION: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "https://partnerservice.iotconnect.io/connectstudio-api-subscription/"
        case .qa:
            return "https://partnerservice.iotconnect.io/connectstudio-api-subscription/"
        case .uat:
            return "https://partnerservice.iotconnect.io/connectstudio-api-subscription/"
        case .prod:
            return "https://partnerservice.iotconnect.io/connectstudio-api-subscription/"
        }
    }

    
    static var BASE_URL_MASTER: String {
        switch EnvironmentSelector.environment {
        case .dev:
            return "avnetmaster.iotconnect.io"
        case .qa:
            return "avnetmaster.iotconnect.io"
        case .uat:
            return "avnetmaster.iotconnect.io"
        case .prod:
            return "avnetmaster.iotconnect.io"
        }
    }

    
    enum HttpStatusCode: Int {
        // 200 Success
        case Http200_OK             = 200
        
        // 400 Client Error
        case Http400_BadRequest     = 400
        case Http401_Unauthorized   = 401
        case Http403_Forbidden      = 403
        case Http404_NotFound       = 404
        case Http408_RequestTimeout = 408
        
        // 500 Server Error
        case Http500_InternalServerError = 500
    }
    
    struct HttpScheme {
        static let secure = "https"
        static let notSecure = "http"
    }
    
    struct requestConstants {
        static let kApplicationHeader        =  "application/x-www-form-urlencoded"
        static let kAuthToken                =  "Authorization"
        static let kContentType              =  "content-Type"
        static let kAcceptType               =  "Accept"
        static let kJSONContent              =  "application/json; charset=UTF-8"
        static let kContentLength            =  "Content-Length"
        static let kAuthorization            =  "Authorization"
        static let kSolutionkey              =  "solution-key"

        struct acceptType {
            static let plainText             =  "text/plain"
            static let json                  =  "application/json-patch+json"
            static let multipart             =  "multipart/form-data;"
        }
    }
    
    struct requestValueConstants {
        static let ksolution_key              =  "Q0EyN0UzRTItMzIxNC00ODI3LUEzNDktQzgwQjU1NkUwRTVFLWFjY2Vzc0tFWS0yMmRqNW5zYzZw"
    }
    
    static var BASIC_TOKEN_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Auth/basic-token"
        }
    }
    
    static var REFRESH_TOKEN_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Auth/refresh-token"
        }
    }
    
    static var CREATE_ROLE_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Role"
        }
    }
    
    static var CREATE_ROLE_PERMISSION: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1.1/Authorize/role-permission"
        }
    }
    
    static var LOGIN_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Auth/login"
        }
    }
    
    static var SUBSCRIPTION_TOKEN_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1/subscription/token"
        }
    }
    
    static var SUBSCRIPTION_ENVIORNMENT_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1/company"
        }
    }
    
    static var SUBSCRIPTION_CONSUMPTION_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "api/v1/subscriber"
        }
    }

    static var SUBSCRIPTION_PLAN_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1/solution"
        }
    }
    
    static var ENTITY_ADD_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Entity"
        }
    }
    
    static var USER_ADD_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/User"
        }
    }
    
    static var USER_DETAIL_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/User/identity"
        }
    }
    
    static var COMPANY_SUBSCRIPTION_DETAIL_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1.1/company/"
        }
    }

    static var AUTHORIZE_MODULE_DETAIL_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1.1/Authorize/module"
        }
    }
    
    static var DEVICE_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device"
        }
    }
    
    static var DEVICE_UPDATE: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device"
        }
    }
    
    static var SINGLE_DEVICE_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device/uniqueId"
        }
    }
    
    static var GET_GRANT_DEVICE_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device"
        }
    }
    
    static var DEVICE_ENTITY_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/entity"
        }
    }

    
    static var COUNTRY_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1.1/Master/country"
        }
    }

    static var STATE_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v1.1/Master/state"
        }
    }

    static var TEMPLATE_ATTRIBUTEL_LIST_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/template-attribute"
        }
    }
    
    static var ENTITY_LOOKUP_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Entity/lookup"
        }
    }
    
    static var ROLE_LOOKUP_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Role/lookup"
        }
    }


    static var TEMPLATE_LOOKUP_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/device-template"
        }
    }

    static var ADD_DEVICE_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/device-template/lookup"
        }
    }
    
    static var TWIN_PROPERTY_LOOKUP_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/template-setting"
        }
    }

    static var EXECUTE_TWIN_PROPERTY_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device"
        }
    }

    static var TWIN_PROPERTY_HISTORY_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Device"
        }
    }

    static var COMMAND_LOOUP_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/template-command"
        }
    }
    
    static var EXECUTE_COMMAND_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/template-command/device"
        }
    }
    
    static var COMMAND_HISTORY_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/template-command/history"
        }
    }

    static var HISTORICAL_DATA_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Telemetry/attribute-history/device"
        }
    }
    
    static var TELEMETRY_DEFAULT_DATA_PATH: String {
        switch EnvironmentSelector.environment {
        case .dev, .qa, .uat, .prod: return "/api/v2/Telemetry/device"
        }
    }
}
