//
//  IOImage.swift
//  InspectionApp
//
//  Created by Krutik S Vora on 27/06/20.
//  Copyright © 2020 Devesh Mevada. All rights reserved.
//

import Foundation
import UIKit

extension UIImage {
    // MARK: - UIImage+Resize
    func compressTo(_ expectedSizeInMb:Float) -> Data? {
        let sizeInBytes = Int(expectedSizeInMb * 1024 * 1024)
        var needCompress:Bool = true
        var imgData:Data?
        var compressingValue:CGFloat = 1.0
        while (needCompress && compressingValue > 0.0) {
            if let data:Data = self.jpegData(compressionQuality: compressingValue) {
                if data.count < sizeInBytes || compressingValue <= 0.11 {
                needCompress = false
                imgData = data
            } else {
                compressingValue -= 0.1
            }
                print("compress = \(compressingValue) count = \(data.count )")

        }

    }
    if let data = imgData {
            return data
    }
        return nil
    }
}
