//
//  IOScrollView.swift
//  InspectionApp
//
//  Created by krutik on 27/07/20.
//  Copyright © 2020 Devesh Mevada. All rights reserved.
//

import Foundation
import UIKit
extension UIScrollView {
 public func takeScreenshotOfFullContent(_ completion: @escaping (() -> Void)) {
  // Page drawing content to ImageContext
  let originalOffset = self.contentOffset

  // When contentSize. height < bounds. height, ensure that at least one page of content is drawn
  var pageNum = 1
  if self.contentSize.height > self.bounds.height {
   pageNum = Int(floorf(Float(self.contentSize.height / self.bounds.height)))
  }

  let backgroundColor = self.backgroundColor ?? UIColor.white
    var documentsFileName :String!
//  UIGraphicsBeginImageContextWithOptions(self.contentSize, true, 0)
    if let documentDirectories = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true).first {
        documentsFileName = documentDirectories + "/" + "sample.pdf"
    }
    UIGraphicsBeginPDFContextToFile(documentsFileName, .zero, nil);

  guard let context = UIGraphicsGetCurrentContext() else {
   completion()
   return
  }
  context.setFillColor(backgroundColor.cgColor)
  context.setStrokeColor(backgroundColor.cgColor)

    for index in 0 ... pageNum{
        self.setContentOffset(CGPoint(x: 0, y: CGFloat(index) * self.frame.size.height), animated: false)
        let pageFrame = CGRect(x: 0, y: CGFloat(index) * self.frame.size.height, width: self.bounds.size.width, height: self.bounds.size.height)
          UIGraphicsBeginPDFPageWithInfo(pageFrame, nil);
    }
    UIGraphicsEndPDFContext();

  self.drawScreenshotOfPageContent(0, maxIndex: pageNum) {
//    UIGraphicsEndPDFContext()x`;

//   self.contentOffset = originalOffset
//    if let documentDirectories = NSSearchPathForDirectoriesInDomains(.documentDirectory, .userDomainMask, true).first {
//        let documentsFileName = documentDirectories + "/" + "sample"
//        debugPrint(documentsFileName)
//        pdfData.write(toFile: documentsFileName, atomically: true)
//    }

   completion()
  }
 }

 fileprivate func drawScreenshotOfPageContent(_ index: Int, maxIndex: Int, completion: @escaping () -> Void) {

  self.setContentOffset(CGPoint(x: 0, y: CGFloat(index) * self.frame.size.height), animated: false)
  let pageFrame = CGRect(x: 0, y: CGFloat(index) * self.frame.size.height, width: self.bounds.size.width, height: self.bounds.size.height)
//    UIGraphicsBeginPDFPageWithInfo(pageFrame, nil);

  DispatchQueue.main.asyncAfter(deadline: DispatchTime.now() + 0.3) {
    
   self.drawHierarchy(in: pageFrame, afterScreenUpdates: true)

   if index < maxIndex {
    self.drawScreenshotOfPageContent(index + 1, maxIndex: maxIndex, completion: completion)
   }else{
    completion()
   }
  }
 }
}
