/* 
Copyright (c) 2022 Swift Models Generated from JSON powered by http://www.json4swift.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

For support, please feel free to contact me at https://www.linkedin.com/in/syedabsar

*/

import Foundation
struct CommandHistory : Codable {
	let data : [CommandHistoryDetail]?
	let status : Int?
	let message : String?
	let count : Int?

	enum CodingKeys: String, CodingKey {

		case data = "data"
		case status = "status"
		case message = "message"
		case count = "count"
	}

	init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: CodingKeys.self)
		data = try values.decodeIfPresent([CommandHistoryDetail].self, forKey: .data)
		status = try values.decodeIfPresent(Int.self, forKey: .status)
		message = try values.decodeIfPresent(String.self, forKey: .message)
		count = try values.decodeIfPresent(Int.self, forKey: .count)
	}

}
struct CommandHistoryDetail : Codable {
    let commandHistoryGuid : String?
    let uniqueId : String?
    let parentDeviceUniqueId : String?
    let status : String?
    let cmdText : String?
    let statusDate : String?
    let createdByName : String?
    let isResend : Bool?
    let resendHistory : ResendHistory?
    let statusText : String?

    enum CodingKeys: String, CodingKey {

        case commandHistoryGuid = "commandHistoryGuid"
        case uniqueId = "uniqueId"
        case parentDeviceUniqueId = "parentDeviceUniqueId"
        case status = "status"
        case cmdText = "cmdText"
        case statusDate = "statusDate"
        case createdByName = "createdByName"
        case isResend = "isResend"
        case resendHistory = "resendHistory"
        case statusText = "statusText"
    }

    init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        commandHistoryGuid = try values.decodeIfPresent(String.self, forKey: .commandHistoryGuid)
        uniqueId = try values.decodeIfPresent(String.self, forKey: .uniqueId)
        parentDeviceUniqueId = try values.decodeIfPresent(String.self, forKey: .parentDeviceUniqueId)
        status = try values.decodeIfPresent(String.self, forKey: .status)
        cmdText = try values.decodeIfPresent(String.self, forKey: .cmdText)
        let strDT =  try (values.decodeIfPresent(String.self, forKey: .statusDate) ?? "")
        statusDate = removeDataFromDate(strDT: strDT)

        createdByName = try values.decodeIfPresent(String.self, forKey: .createdByName)
        isResend = try values.decodeIfPresent(Bool.self, forKey: .isResend)
        resendHistory = try values.decodeIfPresent(ResendHistory.self, forKey: .resendHistory)
        statusText = try values.decodeIfPresent(String.self, forKey: .statusText)
    }

}
struct ResendHistory : Codable {
    let resendCount : Int?
    let execTime : [String]?

    enum CodingKeys: String, CodingKey {

        case resendCount = "resendCount"
        case execTime = "execTime"
    }

    init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        resendCount = try values.decodeIfPresent(Int.self, forKey: .resendCount)
        execTime = try values.decodeIfPresent([String].self, forKey: .execTime)
    }

}
