//
//  CommandList.swift
//  EBV-IoT
//
//  Created by Milan Patel on 08/03/22.
//

import Foundation

struct CommandList : Codable {
    let data : [CommandData]?
    let status : Int?
    let message : String?
}

struct CommandData : Codable {
    let guid : String?
    let templateCode : String?
    let templateName : String?
    let templateDescription : String?
    let createdDate : String?
    let createdBy : String?
    let updatedDate : String?
    let updatedBy : String?
    let firmwareGuid : String?
    let firmwareName : String?
    let isEdgeSupport : Bool?
    let reqAttrPush : Bool?
    let reqSettingPush : Bool?
    let authType : Int?
    let isType2Support : Bool?
    let tag : String?
    let attrXml : String?
    let attributes : [Attributes]?
    let settingXml : String?
//    let settings : [Settings]?
    let commandXml : String?
    let commands : [Commands]?
    let directMethodXml : String?
    let directMethods : String?
    let isValidateTemplate : Int?
    let isValidEdgeSupport : Int?
    let isValidType2Support : Int?
    let isAttachedWithDevice : Bool?
    let dataLength : String?
    let isLowBandwidth : Bool?
    let isIotEdgeEnable : Bool?
    let isSolutionTemplate : Bool?
    let dataFrequency : Int?
    let fileSupport : Bool?
    let messageVersion : String?
}

struct Attributes : Codable {
    let guid : String?
    let localName : String?
    let keyss : [Keys]?
    let createdDate : String?
    let createdBy : String?
    let updatedDate : String?
    let updatedBy : String?
    let parentTemplateAttributeGuid : String?
}

struct Settings : Codable {
    let guid : String?
    let name : String?
    let datatypeGuid : String?
    let dataType : String?
    let createdDate : String?
    let createdBy : String?
    let updatedDate : String?
    let updatedBy : String?
    let localName : String?
    let defaultValue : String?
}

struct Commands : Codable {
    let guid : String?
    let name : String?
    let command : String?
    let createdDate : String?
    let createdBy : String?
    let updatedDate : String?
    let updatedBy : String?
    let requiredParam : Bool?
}

struct Keys : Codable {
    let localName : String?
    let datatypeGuid : String?
    let dataType : String?
}

