//
//  DeviceTemplate.swift
//  EBV-IoT
//
//  Created by Milan Patel on 25/02/22.
//

import Foundation

struct DeviceTemplate : Codable, Hashable {
    let isValidateTemplate : Bool?
    let data : [DataInfo]?
    let status : Int?
    let message : String?
    let count : Int?
}

struct DataInfo : Codable, Hashable {
    static func == (lhs: DataInfo, rhs: DataInfo) -> Bool {
        return lhs.guid == rhs.guid && lhs.localName == rhs.localName && lhs.description == rhs.description
    }
    
    let guid : String?
    var localName : String?
    var devicename : String?
    var description : String?
    let dataTypeGuid : String?
    let dataTypeName : String?
    let createdDate : String?
    let createdby : String?
    let updatedDate : String?
    let dataValidation : String?
    let unit : String?
    let tag : String?
    let sequence : Int?
    let parentTemplateAttributeGuid : String?
    let isTemplateAttributeUsed : Bool?
    let isTagUsed : Bool?
    let aggregateType : [String]?
    let aggregateTypeCount : String?
    let tumblingWindow : String?
    let startIndex : String?
    let numChar : String?
    let attributes : [Attributess]?
    let isPowerBIAttributeUsed : Bool?
    let attributeColor : String?
    let conditionBitValue : Int?
    var min: Double! = 0
    var max: Double! = 0
    var type: String?
    var currentValue: Double! = 0
}

struct Attributess : Codable, Hashable {
    let guid : String?
    let localName : String?
    let description : String?
    let dataTypeGuid : String?
    let dataTypeName : String?
    let unit : String?
    let sequence : Int?
    let parentTemplateAttributeGuid : String?
    let isTemplateAttributeUsed : Int?
    let isPowerBIAttributeUsed : Bool?
    let attributeColor : String?
    let conditionBitValue : Int?
}
