//
//  LoginData.swift
//  EBV-IoT
//
//  Created by Milan Patel on 07/02/22.
//

import Foundation

struct BasicToken: Codable
{
    let data: String?
    let status: Int
    let message: String?
}

struct LoginData: Codable
{
    let token_type: String?
    let access_token: String?
    let expires_in: Int
    let refresh_token: String?
    let status: Int
}

struct LoginDetail: Codable
{
    let data: UserDetail?
    let status: Int
    let message: String?
}

struct UserDetail: Codable
{
    let companyLogo : String?
    let firstName : String?
    let lastName : String?
    let timezoneGuid : String?
    let version : String?
    let uiVersion : String?
    let parentEntityGuid : String?
    let pageSize : Int?
    let userGuid : String?
    let roleGuid : String?
    let companyGuid : String?
    let companyLogoUrl : String?
    let permissions : String?
    let companyName : String?
    let roleName : String?
    let cpId : String?
    let entityGuid : String?
    let solutionGuid : String?
    let isCompanyAdmin : Bool?
    let authFeatures : AuthFeatures?
    let configSettings : String?
    let userId : String?
    let isDefaultDashboard : Bool?
    let isServiceAccountEnabled : Bool?
    let companyType : Int?
}

struct CompanyDetail: Codable
{
    let data : [CompanyDetails]?
    let status : Int?
    let message : String?
}

struct CompanyDetails: Codable
{
    let name : String?
    let solutionGuid : String?
    let solutionSubscriptionGuid : String?
    let subscription : String?
    let subscriptionEndDate : String?
    let type : Int?
}

struct AutorizeMoudle: Codable
{
    let data : [AutorizeMoudleDetail]?
    let status : Int?
    let message : String?
}

struct AutorizeMoudleDetail: Codable
{
    let guid : String?
    let name : String?
    let categoryName : String?
    let permission : Int?
}


struct AuthFeatures : Codable {
    let authType : String?
    let features : [Features]?
}

struct Features : Codable {
    let featureId : Int?
    let featureName : String?
    let isEnable : Bool?
}
