//
//  SingleDevice.swift
//  EBV-IoT
//
//  Created by Milan Patel on 24/05/22.
//

import Foundation

struct SingleDevice: Codable
{
    let data: [SingleDeviceInfo]?
    let status: Int
    let message: String?
}

struct SingleDeviceInfo : Codable {
    let guid : String?
    let uniqueId : String?
    let displayName : String?
    let isConnected : Bool?
    let lastActivityDate : String?
    let isActive : Bool?
    let firmwareUpgradeGuid : String?
    let deviceTemplateGuid : String?
    let entityGuid : String?
    let certificateGuid : String?
    let certificateName : String?
    let certificateType : String?
    let deviceTemplateAuthType : Int?
    let entityName : String?
    let deviceTemplateName : String?
    let note : String?
    let image : String?
    let cpId : String?
    let isAcquired : Int?
    let firmwareAvail : Int?
    let parentDeviceGuid : String?
    let tag : String?
    let parentDeviceUniqueId : String?
    let isParentAcquired : Int?
    let isSimulatorOn : Int?
    let isType2Support : Bool?
    let isEdgeSupport : Bool?
    let isAllottedDevice : Int?
    let allottedDevicePermission : AllottedDevicePermission?
    let imageUrl : String?
    let properties : String?
    let deviceStatus : String?
    let isLowBandwidth : Bool?
    let isIotEdgeEnable : Bool?
    let isSolutionTemplate : Bool?
    let fileSupport : Bool?
    let msgCode : String?
    let messageVersion : String?
    let hasTwin : Bool?
    let hasDirectMethod : Bool?
    let parentCompanyGuid : String?
}

struct AllottedDevicePermission : Codable {
    let view : Bool?
    let operation : Bool?
}
