/* 
Copyright (c) 2022 Swift Models Generated from JSON powered by http://www.json4swift.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

For support, please feel free to contact me at https://www.linkedin.com/in/syedabsar

*/

import Foundation
struct TwinProperty : Codable {
	let data : [TwinPropertyDetail]?
	let status : Int?
	let message : String?

	enum CodingKeys: String, CodingKey {

		case data = "data"
		case status = "status"
		case message = "message"
	}

	init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: CodingKeys.self)
		data = try values.decodeIfPresent([TwinPropertyDetail].self, forKey: .data)
		status = try values.decodeIfPresent(Int.self, forKey: .status)
		message = try values.decodeIfPresent(String.self, forKey: .message)
	}

}
struct TwinPropertyDetail : Codable {
    let guid : String?
    let name : String?
    let localName : String?
    let defaultValue : String?
    let dataTypeName : String?
    let dataValidation : String?
    let isReadOnly : Bool?

    enum CodingKeys: String, CodingKey {

        case guid = "guid"
        case name = "name"
        case localName = "localName"
        case defaultValue = "defaultValue"
        case dataTypeName = "dataTypeName"
        case dataValidation = "dataValidation"
        case isReadOnly = "isReadOnly"
    }

    init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        guid = try values.decodeIfPresent(String.self, forKey: .guid)
        name = try values.decodeIfPresent(String.self, forKey: .name)
        localName = try values.decodeIfPresent(String.self, forKey: .localName)
        defaultValue = try values.decodeIfPresent(String.self, forKey: .defaultValue)
        dataTypeName = try values.decodeIfPresent(String.self, forKey: .dataTypeName)
        dataValidation = try values.decodeIfPresent(String.self, forKey: .dataValidation)
        isReadOnly = try values.decodeIfPresent(Bool.self, forKey: .isReadOnly)
    }

}
