/* 
Copyright (c) 2022 Swift Models Generated from JSON powered by http://www.json4swift.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

For support, please feel free to contact me at https://www.linkedin.com/in/syedabsar

*/

import Foundation
struct TwinPropertyHistory : Codable {
	let data : [TwinPropertyHistoryDetail]?
	let status : Int?
	let message : String?

	enum CodingKeys: String, CodingKey {

		case data = "data"
		case status = "status"
		case message = "message"
	}

	init(from decoder: Decoder) throws {
		let values = try decoder.container(keyedBy: CodingKeys.self)
		data = try values.decodeIfPresent([TwinPropertyHistoryDetail].self, forKey: .data)
		status = try values.decodeIfPresent(Int.self, forKey: .status)
		message = try values.decodeIfPresent(String.self, forKey: .message)
	}

}
struct TwinPropertyHistoryDetail : Codable {
    let guid : String?
    let companyGuid : String?
    let templateSettingGuid : String?
    let deviceGuid : String?
    let createdDate : String?
    let sdkDate : String?
    let gatewayDate : String?
    let deviceDate : String?
    let desiredValue : String?
    let reportedValue : String?
    let desiredUpdatedDate : String?
    let reportedUpdatedDate : String?
    let desiredVersion : String?
    let name : String?
    let localName : String?
    let dataTypeName : String?
    let cpId : String?
    let uniqueId : String?
    let daTypeGuid : String?
    let isFault : Bool?
    let entityGuid : String?
    let isReadOnly : Bool?

    enum CodingKeys: String, CodingKey {

        case guid = "guid"
        case companyGuid = "companyGuid"
        case templateSettingGuid = "templateSettingGuid"
        case deviceGuid = "deviceGuid"
        case createdDate = "createdDate"
        case sdkDate = "sdkDate"
        case gatewayDate = "gatewayDate"
        case deviceDate = "deviceDate"
        case desiredValue = "desiredValue"
        case reportedValue = "reportedValue"
        case desiredUpdatedDate = "desiredUpdatedDate"
        case reportedUpdatedDate = "reportedUpdatedDate"
        case desiredVersion = "desiredVersion"
        case name = "name"
        case localName = "localName"
        case dataTypeName = "dataTypeName"
        case cpId = "cpId"
        case uniqueId = "uniqueId"
        case daTypeGuid = "daTypeGuid"
        case isFault = "isFault"
        case entityGuid = "entityGuid"
        case isReadOnly = "isReadOnly"
    }

    init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        guid = try values.decodeIfPresent(String.self, forKey: .guid)
        companyGuid = try values.decodeIfPresent(String.self, forKey: .companyGuid)
        templateSettingGuid = try values.decodeIfPresent(String.self, forKey: .templateSettingGuid)
        deviceGuid = try values.decodeIfPresent(String.self, forKey: .deviceGuid)
        createdDate = try values.decodeIfPresent(String.self, forKey: .createdDate)
        sdkDate = try values.decodeIfPresent(String.self, forKey: .sdkDate)
        gatewayDate = try values.decodeIfPresent(String.self, forKey: .gatewayDate)
        deviceDate = try values.decodeIfPresent(String.self, forKey: .deviceDate)
        desiredValue = try (values.decodeIfPresent(String.self, forKey: .desiredValue) ?? "NA")
        reportedValue = try (values.decodeIfPresent(String.self, forKey: .reportedValue) ?? "NA")
        let strDT =  try (values.decodeIfPresent(String.self, forKey: .desiredUpdatedDate) ?? "")
        desiredUpdatedDate = removeDataFromDate(strDT: strDT)
        let strReportDT =  try (values.decodeIfPresent(String.self, forKey: .reportedUpdatedDate) ?? "")
        reportedUpdatedDate = removeDataFromDate(strDT: strReportDT)
        desiredVersion = try values.decodeIfPresent(String.self, forKey: .desiredVersion)
        name = try values.decodeIfPresent(String.self, forKey: .name)
        localName = try values.decodeIfPresent(String.self, forKey: .localName)
        dataTypeName = try values.decodeIfPresent(String.self, forKey: .dataTypeName)
        cpId = try values.decodeIfPresent(String.self, forKey: .cpId)
        uniqueId = try (values.decodeIfPresent(String.self, forKey: .uniqueId) ?? "")
        daTypeGuid = try (values.decodeIfPresent(String.self, forKey: .daTypeGuid) ?? "NA")
        isFault = try values.decodeIfPresent(Bool.self, forKey: .isFault)
        entityGuid =  try (values.decodeIfPresent(String.self, forKey: .entityGuid) ?? "NA")
        isReadOnly = try values.decodeIfPresent(Bool.self, forKey: .isReadOnly)
    }

}
func removeDataFromDate(strDT:String) -> String{
    let strDate = strDT.split(separator: ".")
    return String(strDate[0])
}
