//
//  GaugeCell.swift
//  EBV-IoT
//
//  Created by Milan Patel on 02/03/22.
//

import UIKit

class GaugeCell: UITableViewCell {

    @IBOutlet weak var chartView: WMGaugeView!
    @IBOutlet weak var chartBackView: UIView!
    @IBOutlet weak var lblTitle: UILabel!
    @IBOutlet weak var lblCurrentValue: UILabel!
    @IBOutlet weak var lblMin: UILabel!
    @IBOutlet weak var lblMax: UILabel!
    @IBOutlet weak var bottomConstraintSubView: NSLayoutConstraint!

    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
    func initGraph(minValue : Float, maxValue : Float, sensorName : String)
    {
        let style = WMGaugeViewStyleFlatThin()
        style.needleScrewRadius = 0.05;
        style.needleHeight = 0.45;
        style.needleScrewColor = UIColor.lightGray
        style.needleColor = UIColor.black
        chartView.style = style
//        let findRedValue = maxValue * 0.80
        let total = maxValue - minValue
        let redval = total * 0.8
        let findRedValue = minValue + redval
        chartView.minValue = minValue
        chartView.maxValue = maxValue
        chartView.showRangeLabels = true
        chartView.rangeValues = [ NSNumber(value: findRedValue),NSNumber(value: maxValue)]
        chartView.rangeColors = [UIColor(red: 0.0/255.0, green: 206.0/255.0, blue: 39.0/255.0, alpha: 1.0),UIColor(red: 251.0/255.0, green: 84.0/255.0, blue: 84.0/255.0, alpha: 1.0)]//[ RGB(232, 111, 33),    RGB(232, 231, 33)];
        chartView.showUnitOfMeasurement = false
        chartView.scaleDivisionsWidth = 0.008
        chartView.scaleSubdivisionsWidth = 0.006
        chartView.rangeLabelsFontColor = UIColor.black
        chartView.rangeLabelsWidth = 0.1
        chartView.showScale = false
        chartView.showInnerBackground = false
        chartView.scaleStartAngle = 90
        chartView.scaleEndAngle = 270
        
        let value: Float = Float(lblCurrentValue.text!) ?? 0.0
        chartView.setValue(value, animated: true)
        
        lblMin.text = forTrailingZero(temp: minValue)
        lblMax.text = forTrailingZero(temp: maxValue)

        self.lblTitle.text = "\(sensorName)"
    }
    func loadGraph(value : Float){
        chartView.setValue(value, animated: true)
        lblCurrentValue.text = String(format: "%@", String(format: "%g", value))
    }
    
    func forTrailingZero(temp: Float) -> String {
        let tempVar = String(format: "%g", temp)
        return tempVar
    }
}
