//
//  HistoryGraphCell.swift
//  EBV-IoT
//
//  Created by Milan Patel on 05/04/22.
//

import UIKit
import Charts

class HistoryGraphCell: UITableViewCell {

    @IBOutlet weak var chartView: LineChartView!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.initLineGraph()
    }
    
    func initLineGraph()
    {
        chartView.dragEnabled = true
        chartView.setScaleEnabled(true)
        chartView.pinchZoomEnabled = false
        chartView.xAxis.labelFont =  NSUIFont.systemFont(ofSize: 8.0)
        chartView.xAxis.labelPosition = .bottom
        chartView.xAxis.granularityEnabled = true
        chartView.xAxis.granularity = 1.0
        chartView.xAxis.avoidFirstLastClippingEnabled = false
        chartView.rightAxis.enabled = false
        
        let l = chartView.legend
        l.verticalAlignment = .bottom
        l.horizontalAlignment = .center
        l.orientation = .horizontal
        l.drawInside = false
        l.form = .square
        l.formSize = 9
        l.xEntrySpace = 5
        l.yOffset = 20.0
        l.textColor = UIColor.black
        l.enabled = false
    }


    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
}
