//
//  LineGraphCell.swift
//  EBV-IoT
//
//  Created by Milan Patel on 18/02/22.
//

import UIKit
import Charts

class LineGraphCell: UITableViewCell {

    @IBOutlet var VWData : UIView!
    @IBOutlet weak var chartView: LineChartView!
    @IBOutlet weak var btn_orientation: UIButton!
    @IBOutlet weak var lblTitle: UILabel!

    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.initLineGraph()
    }

    override func setSelected(_ selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
    //MARK:- Graph Integration
    func initLineGraph()
    {
        //chartView.xAxis.labelFont = .boldSystemFont(ofSize: 10)
        chartView.dragEnabled = true
        chartView.setScaleEnabled(false)
        chartView.pinchZoomEnabled = false
//        chartView.xAxis.labelRotationAngle = -90
        chartView.xAxis.labelFont =  NSUIFont.systemFont(ofSize: 8.0)
        chartView.xAxis.labelPosition = .bottom
        chartView.xAxis.granularityEnabled = true
        chartView.xAxis.granularity = 1.0
        chartView.xAxis.avoidFirstLastClippingEnabled = false
//        chartView.xAxis.drawGridLinesEnabled = false
//        chartView.leftAxis.drawGridLinesEnabled = false
        chartView.rightAxis.enabled = false
        
        let l = chartView.legend
        l.verticalAlignment = .bottom
        l.horizontalAlignment = .center
        l.orientation = .horizontal
        l.drawInside = false
        l.form = .square
        l.formSize = 9
        l.xEntrySpace = 5
        l.textColor = UIColor.black
        l.enabled = true
        

        // set label entry
//        chartView.legend.verticalAlignment = Legend.VerticalAlignment.bottom
//        chartView.legend.enabled = true
//        chartView.legend.form = .none
//        chartView.legend.textColor = UIColor.black
//        chartView.legend.horizontalAlignment = .center
//        chartView.fitScreen()
    }
    
}
