//
//  Userdefaults.swift
//  Procell
//
//  Created by Megha Salla on 10/11/21.
//

import Foundation

enum UserDefault: String {
    
    // MARK: - Application preference keyes
    case email    = "Email"
    case rootemail    = "RootEmail"
    case rootpass    = "RootPass"
    case password    = "Password"
    case basictoken    = "BasicToken"
    case accesstoken    = "AccessToken"
    case refreshtoken    = "Refreshtoken"
    case rootaccesstoken    = "RootAccessToken"
    case rootrefreshtoken    = "RootRefreshtoken"
    case firstname    = "firstName"
    case lastname    = "lastName"
    case cpId    = "cpId"
    case entityGuid    = "entityGuid"
    case rootentityGuid    = "rootentityGuid"
    case userGuid = "userGuid"
    case parentEntityGuid = "parentEntityGuid"
    case companyGuid    = "companyGuid"
    case templateGuid    = "templateGuid"
    case isLogin    = "isLogin"
    case isRootLogin    = "isRootLogin"
    case deviceAdded    = "deviceAdded"
    case accesstokenSubscription    = "accesstokenSubscription"
}

class UserDefaultManager: NSObject {
    
    static let shared = UserDefaultManager()
    subscript(preference: UserDefault) -> Any? {
        get {
            return UserDefaults.standard.value(forKey: preference.rawValue)
        }
        
        set(newValue) {
            if newValue == nil {
                UserDefaults.standard.removeObject(forKey: preference.rawValue)
                UserDefaults.standard.synchronize()
            } else {
                UserDefaults.standard.set(newValue, forKey: preference.rawValue)
                UserDefaults.standard.synchronize()
            }
        }
    }
}

//
//
//struct UserDefault {
//    static let email = "Email"
//    static let password = "Password"
//    static let rememberMe = "RememberMe"
//}
//
//
//class UserDefaultHelper {
//    fileprivate static let kRememberMe = "RememberMe"
//
//    class var rememberMe: Bool {
//        get {
//            return UserDefaults.standard.bool(forKey: kRememberMe)
//        }
//
//        set {
//            UserDefaults.standard.setValue(newValue, forKey: kRememberMe)
//            UserDefaults.standard.synchronize()
//        }
//    }
//}
