//
//  DeviceDetailVC.swift
//  EBV-IoT
//
//  Created by krutik vora on 07/02/22.
//

import UIKit

class DeviceDetailVC: UIViewController,UICollectionViewDelegate,UICollectionViewDataSource,UICollectionViewDelegateFlowLayout {
    @IBOutlet weak var titleCollection: UICollectionView!
    
    @IBOutlet weak var containerVC: UIView!

    @IBOutlet weak var lblNavigationTitle: UILabel!
    var strNavigationTitle : String!
    var arrTitle : [String] = [String]()
    var selectedIndex : Int = 0
    var strDeviceID : String = ""
    var strDeviceGUID : String = ""
    @IBOutlet weak var viewTop: UIView!
    var strDeviceTemplateGUID : String = "Device4"
    var strDeviceName : String = "Device4"
    var connected : Bool = false

    var selectedVC : UIViewController!
    @IBOutlet weak var lblStatus: UILabel!
    @IBOutlet weak var containerlayout: NSLayoutConstraint!
    @IBOutlet weak var containenavigationlayout: NSLayoutConstraint!

    
    
    private lazy var objDataVC: DataVC = {
        // Load Storyboard
        let objData = UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DataVC") as! DataVC
        objData.strDeviceName = self.strDeviceName
        objData.strDeviceID = self.strDeviceID
        objData.strDeviceGUID = self.strDeviceGUID
        objData.strDeviceTemplateGUID = self.strDeviceTemplateGUID
        //objData.connect = connected
        objData.isDeviceConnected = { status in
            if status == true{
                debugPrint(" *****  Device is Connected *****")
                self.lblStatus.backgroundColor = .systemGreen
            }
            else{
                debugPrint(" *****  Device is  disConnected *****")
                self.lblStatus.backgroundColor = .systemRed
            }
        }
        
        objData.parentvc = self

//        // Add View Controller as Child View Controller
//        self.add(asChildViewController: objData)

        return objData
    }()

    private lazy var objHistoryVC: HistoryVC = {
        // Load Storyboard
        let objViewController = UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "HistoryVC") as! HistoryVC
        objViewController.strDeviceName = self.strDeviceName
        objViewController.strDeviceID = self.strDeviceID
        objViewController.strDeviceGUID = self.strDeviceGUID
        objViewController.strDeviceTemplateGUID = self.strDeviceTemplateGUID

        objViewController.parentvc = self
        
        // Add View Controller as Child View Controller
        self.add(asChildViewController: objViewController)

        return objViewController
    }()

    private lazy var objPropertiesVC: PropertiesVC = {
        // Load Storyboard
        let objViewController = UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "PropertiesVC") as! PropertiesVC
        objViewController.strDeviceName = self.strDeviceName
        objViewController.strDeviceID = self.strDeviceID
        objViewController.strDeviceTemplateGUID = self.strDeviceTemplateGUID

        // Add View Controller as Child View Controller
        self.add(asChildViewController: objViewController)

        return objViewController
    }()

    private lazy var objCommandVC: CommandVC = {
        // Load Storyboard
        let objViewController = UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "CommandVC") as! CommandVC
        objViewController.strDeviceName = self.strDeviceName
        objViewController.strDeviceID = self.strDeviceID
        objViewController.strDeviceTemplateGUID = self.strDeviceTemplateGUID
        objViewController.strDeviceGUID = self.strDeviceGUID

        // Add View Controller as Child View Controller
        self.add(asChildViewController: objViewController)

        return objViewController
    }()

    override func viewDidLoad() {
        super.viewDidLoad()
        

        arrTitle.append("Data")
        arrTitle.append("History")
        arrTitle.append("Properties")
        arrTitle.append("Command")
        titleCollection.register(UINib(nibName: "DeviceDetailCollectionCell", bundle: nil), forCellWithReuseIdentifier: "DeviceDetailCollectionCell")
        viewTop.layer.cornerRadius = 15
        viewTop.layer.maskedCorners = [.layerMinXMaxYCorner, .layerMaxXMaxYCorner]
        viewTop.clipsToBounds = true

        add(asChildViewController: objDataVC)
        selectedVC = objDataVC
        
        titleCollection.selectItem(at: IndexPath(row: 0, section: 0), animated: true, scrollPosition: .centeredHorizontally)
        self.lblNavigationTitle.text = strNavigationTitle
        self.lblNavigationTitle.adjustsFontSizeToFitWidth = true
        
        lblStatus.layer.cornerRadius = lblStatus.frame.width/2
        lblStatus.layer.masksToBounds = true
        if connected {
            lblStatus.backgroundColor = .systemGreen
        } else  {
            lblStatus.backgroundColor = .systemRed
        }
        
        self.titleCollection.scrollToItem(at:IndexPath(item: 0, section: 0), at: .left, animated: false)
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        self.sideMenuController()?.sideMenu?.allowPanGesture = false
        self.sideMenuController()?.sideMenu?.allowRightSwipe = false
    }
    
   override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        Constant.appDelegate.arr_Color_Sensor.removeAll()
        Constant.appDelegate.arr_History_Sensor.removeAll()
        Constant.appDelegate.isLoad = false
    }
    
    private func add(asChildViewController viewController: UIViewController) {
        // Add Child View Controller
        addChild(viewController)
        
        // Add Child View as Subview
        containerVC.addSubview(viewController.view)

        // Configure Child View
        viewController.view.frame = containerVC.bounds
        viewController.view.autoresizingMask = [.flexibleWidth, .flexibleHeight]

        // Notify Child View Controller
        viewController.didMove(toParent: self)
    }

    
    private func remove(asChildViewController viewController: UIViewController) {
        // Notify Child View Controller
//        viewController.willMove(toParent: nil)
//
//        // Remove Child View From Superview
//        viewController.view.removeFromSuperview()
//
//        // Notify Child View Controller
//        viewController.removeFromParent()
        viewController.view.isHidden = true
    }
    
    func updateView(){
        remove(asChildViewController: selectedVC)
        if selectedIndex == 0{
            objDataVC.view.isHidden = false
//            add(asChildViewController: objDataVC)
            selectedVC = objDataVC
        } else if selectedIndex == 1 {
            objHistoryVC.view.isHidden = false

//            add(asChildViewController: objHistoryVC)
            selectedVC = objHistoryVC
        } else if selectedIndex == 2 {
            objPropertiesVC.view.isHidden = false

//            add(asChildViewController: objPropertiesVC)
            selectedVC = objPropertiesVC
        } else if selectedIndex == 3 {
            objCommandVC.view.isHidden = false
            
            if Constant.appDelegate.isLoad {
                objCommandVC.viewWillAppear(true)
            } else {
                Constant.appDelegate.isLoad = true
            }

//            add(asChildViewController: objCommandVC)
            selectedVC = objCommandVC
        }
    }

    @IBAction func btnSideMEnuClick(sender : UIButton){
            self.navigationController?.popViewController(animated: true)
    }

    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return arrTitle.count
    }
    
    // make a cell for each cell index path
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        
        // get a reference to our storyboard cell
        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "DeviceDetailCollectionCell", for: indexPath as IndexPath) as! DeviceDetailCollectionCell
        cell.lblName.text = arrTitle[indexPath.row]
//        cell.contentView.backgroundColor = .red
        if indexPath.row == selectedIndex{
            cell.lblName.textColor = UIColor.white
            cell.lblStatus.backgroundColor = UIColor(red: 0.0/255.0, green: 57.0/255.0, blue: 139.0/255.0, alpha: 1.0)
        } else {
            cell.lblName.textColor = UIColor.white
            cell.lblStatus.backgroundColor = UIColor(red: 156.0/255.0, green: 199.0/255.0, blue: 227.0/255.0, alpha: 1.0)
        }
        return cell
    }
    
    func collectionView(_ collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAt indexPath: IndexPath) -> CGSize {
            let label = UILabel(frame: CGRect.zero)
            label.text = arrTitle[indexPath.item]
//            label.sizeToFit()
      //  return CGSize(width: 500, height: 44)
        return CGSize(width: collectionView.frame.size.width / 4, height: 44)

        }

    // MARK: - UICollectionViewDelegate protocol
    
//    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
//        // handle tap events
//        print("You selected cell #\(indexPath.item)!")
//
//        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "DeviceDetailCollectionCell", for: indexPath) as! DeviceDetailCollectionCell
//        cell.lblName.textColor = UIColor.white
//        cell.lblStatus.backgroundColor = UIColor(red: 0.0/255.0, green: 57.0/255.0, blue: 139.0/255.0, alpha: 1.0)
//        cell.lblName.backgroundColor = UIColor.white
//
//    }
//
//    func collectionView(_ collectionView: UICollectionView, didDeselectItemAt indexPath: IndexPath){
////        let cell = collectionView.dequeueReusableCell(withReuseIdentifier: "DeviceDetailCollectionCell", for: indexPath) as! DeviceDetailCollectionCell
////        cell.lblName.textColor = UIColor(red: 156.0/255.0, green: 156.0/255.0, blue: 199.0/255.0, alpha: 1.0)
////        cell.lblStatus.backgroundColor = UIColor(red: 156.0/255.0, green: 156.0/255.0, blue: 199.0/255.0, alpha: 1.0)
//
//    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        if Constant.appDelegate.isConnectedToNetwork(){
            self.selectedIndex = indexPath.row
            self.titleCollection.reloadData()
            print("Internet Connection Available!")
            updateView()
        }else{
            print("Internet Connection not Available!")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
        }
    }

    func collectionView(_ collectionView: UICollectionView, didDeselectItemAt indexPath: IndexPath) {
//        if let cell = collectionView.cellForItem(at: indexPath) as? DeviceDetailCollectionCell {
//            cell.lblName.textColor = UIColor(red: 156.0/255.0, green: 199.0/255.0, blue: 227.0/255.0, alpha: 1.0)
//            cell.lblStatus.backgroundColor = UIColor(red: 156.0/255.0, green: 199.0/255.0, blue: 227.0/255.0, alpha: 1.0)
//        }
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}
