//
//  PropertiesVC.swift
//  EBV-IoT
//
//  Created by krutik vora on 08/02/22.
//

import UIKit
import SkyFloatingLabelTextField
class PropertiesVC: UIViewController,UITextFieldDelegate,UIPickerViewDelegate,UIPickerViewDataSource {

    @IBOutlet weak var txtTwinProperty: SkyFloatingLabelTextField!
    @IBOutlet weak var txtDesireValue: SkyFloatingLabelTextField!
    @IBOutlet weak var tblProperty: UITableView!
    var arrTwinProperty : [TwinPropertyDetail]!
    var arrTwinPropertyHistory : [TwinPropertyHistoryDetail]!
    var strDeviceID : String = ""
    var strDeviceTemplateGUID : String = ""
    var strDeviceName : String = ""

    @IBOutlet  var viewPickerBack: UIView!
    @IBOutlet  var viewPicker: UIView!
    @IBOutlet  var pickerview: UIPickerView!
    @IBOutlet  var toolbar: UIToolbar!
    @IBOutlet  var barbuttoncancel: UIBarButtonItem!
    @IBOutlet  var barbuttondone: UIBarButtonItem!
    var selectedRow : Int = 0
    var strPropertyID : String = ""
    var strPropertylocalname : String = ""

    override func viewDidLoad() {
        super.viewDidLoad()
        let objRightView = UIImageView(frame: CGRect(x: 0, y: 0, width: 30, height: 45))
        objRightView.image = UIImage(named: "down-arrow.png")
        self.txtTwinProperty.rightViewMode = .always
        objRightView.backgroundColor = .clear
        objRightView.contentMode = .bottom
        objRightView.tintColor = UIColor(red: 0.0/255.0, green: 57.0/255.0, blue: 139.0/255.0, alpha: 1.0)
        self.txtTwinProperty.rightView = objRightView
        tblProperty.register(UINib(nibName: "PropertyCustomCell", bundle: nil), forCellReuseIdentifier: "PropertyCustomCell")
//        callTwinPropertiesHistoryWS()
        print("PropertiesVC viewDidLoad")

        // Do any additional setup after loading the view.
    }
    
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        if Constant.appDelegate.isConnectedToNetwork(){
            print("Internet Connection Available!")
            callTwinPropertyListWS()
            selectedRow  = 0
            strPropertyID  = ""
            self.txtTwinProperty.text = "Select Twin Property"
            self.txtDesireValue.text = ""
            self.viewPickerBack.isHidden = true
            self.viewPicker.isHidden = true
        }else{
            print("Internet Connection not Available!")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
        }
        
        print("PropertiesVC viewWillAppear")
    }

    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated) // No need for semicolon
        
        Constant.AppUtility.lockOrientation(.portrait)
    }

    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        print("PropertiesVC viewWillDisappear")
    }

    @IBAction func barClickCancel(_ sender: AnyObject)    {
        self.viewPicker.isHidden = true
        self.viewPickerBack.isHidden = true

    }

    @IBAction func barClickDone(_ sender: AnyObject)    {
        if self.arrTwinProperty != nil {
            if self.arrTwinProperty.count > 0 {
                self.txtTwinProperty.text = self.arrTwinProperty[selectedRow].name
                self.strPropertyID = self.arrTwinProperty[selectedRow].guid!
                self.strPropertylocalname = self.arrTwinProperty[selectedRow].localName!
            }
        }
        self.viewPickerBack.isHidden = true
        self.viewPicker.isHidden = true
    }

    // MARK: - PickerView Delegate
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if self.arrTwinProperty != nil{
            return self.arrTwinProperty.count
        }
        return 0
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
            return self.arrTwinProperty[row].name
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int)
    {
            selectedRow = row
    }


    // MARK: - DeviceLists Web-Service
    func callTwinPropertyListWS()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            ProHudManager.shared.show(view: self.view.superview?.superview, animated: true)
            DeviceManager.shared.twinPropertiesListWebService(deviceTemplateGUID: self.strDeviceTemplateGUID,paramers: dict ,successBlock: { (response) in
//                ProHudManager.shared.hide(animated: true)
                print(response)
                let decoder = JSONDecoder()
                let twinProperty = try? decoder.decode(TwinProperty.self, from: response)
                if twinProperty != nil{
                    self.arrTwinProperty = twinProperty?.data
                }
                self.callTwinPropertiesHistoryWS()
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
//                ProHudManager.shared.hide(animated: true)
                self.callTwinPropertiesHistoryWS()

            })
        }
    }

    func callTwinPropertiesHistoryWS()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            DeviceManager.shared.propertiesHistoryWebService(strDeviceID:self.strDeviceID ,paramers: dict ,successBlock: { (response) in
                ProHudManager.shared.hide(animated: true)
                print(response)
                let decoder = JSONDecoder()
                let twinProperty = try? decoder.decode(TwinPropertyHistory.self, from: response)
                if twinProperty != nil{
                    DispatchQueue.main.async {

                        if (twinProperty?.data!.count)! > 0 {
                            self.tblProperty.isHidden = false
                            self.arrTwinPropertyHistory = twinProperty?.data
                            self.tblProperty.reloadData()
                        } else {
                            self.tblProperty.isHidden = true
                        }
                    }
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                DispatchQueue.main.async {
                    self.tblProperty.isHidden = true
                }
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
    
    func callExecutePropertyWS()
    {
        DispatchQueue.main.async { [self] in
            var dict : [String : Any] = [:]
            dict["localName"] = self.arrTwinProperty[selectedRow].localName!
            dict["desiredValue"] = self.txtDesireValue.text
            dict["templateSettingGuid"] = self.strPropertyID

            ProHudManager.shared.show(view: self.view.superview?.superview, animated: true)
            DeviceManager.shared.executeTwinPropertyWebService(deviceName:self.strDeviceID ,paramers: dict ,successBlock: { (response) in
//                ProHudManager.shared.hide(animated: true)
                do {
                    if let json = try JSONSerialization.jsonObject(with: response, options: []) as? [String: Any] {
                        // try to read out a string array
                        AlertConstant.showAlertMessage(self, Message: json["message"] as! String)
                        self.callTwinPropertiesHistoryWS()

                    }
                } catch let error as NSError {
                    print("Failed to load: \(error.localizedDescription)")
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
                AlertConstant.showAlertMessage(self, Message: (error as! EBVHttpErrors).errorDescription)
            })
        }
    }


    // MARK: - Button Action
    
    @IBAction func btnExecuteCommand(sender : UIButton){
        if strPropertyID == "" {
            AlertConstant.showAlertMessage(self, Message: "Please select twin property.")

        } else if self.txtDesireValue.text?.trimmingCharacters(in: .whitespaces).count == 0{
            AlertConstant.showAlertMessage(self, Message: "Please select desired value.")
        } else {
            if Constant.appDelegate.isConnectedToNetwork(){
                callExecutePropertyWS()
            }else{
                print("Internet Connection not Available!")
                ProHudManager.shared.hide(animated: true)
                AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
            }
        }
    }

    // MARK: - TextField Delegate
    
    func textFieldShouldBeginEditing(_ textField: UITextField) -> Bool {
        if textField == txtTwinProperty{
            if self.arrTwinProperty.count > 0 {
                if self.viewPicker.isHidden == true{
                    self.viewPickerBack.isHidden = false
                    self.viewPicker.isHidden = false
                    self.pickerview.isHidden = false
                    self.pickerview.reloadAllComponents()
                    
                    //Set scrollview frame
                    UIView.animate(withDuration: 0.5,
                                   delay: 0.0,
                                   options: UIView.AnimationOptions.curveEaseIn,
                                   animations: { () -> Void in
                                    
                                    self.viewPicker.frame = CGRect(origin: CGPoint(x: 0.0, y: (self.view.frame.size.height - self.viewPicker.frame.size.height) ), size: CGSize(width: self.viewPicker.frame.size.width, height:self.viewPicker.frame.size.height))
                                    
                                   }, completion: { (finished) -> Void in
                                    
                                   })
                }
                return false
            }
            return true
        } else {
            return true
        }
    }

    
    func formatDate(strDate:String,currentFormat:String,newDateFormat:String) -> String{
        
        let dtFormat = DateFormatter()
        dtFormat.dateFormat = currentFormat
        let dt = dtFormat.date(from: strDate)
        dtFormat.dateFormat = newDateFormat
        let strDate = dtFormat.string(from: dt!)
        return strDate

    }
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}
extension PropertiesVC: UITableViewDelegate {
    
    // didSelectRowAtIndexPath - change background color
//    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
//        tableView.deselectRow(at: indexPath, animated: true)
//    }
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 250
    }
    

}

extension PropertiesVC: UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        if self.arrTwinPropertyHistory == nil {
            return 0
        }
        return self.arrTwinPropertyHistory.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "PropertyCustomCell", for: indexPath) as! PropertyCustomCell
        cell.selectionStyle = .none
        let objTwinPropertyHistory = self.arrTwinPropertyHistory[indexPath.row]
        cell.lblName.text = objTwinPropertyHistory.localName
        cell.lblDesierValue.text = objTwinPropertyHistory.desiredValue
        let strdesiredUpdatedDate = self.formatDate(strDate: objTwinPropertyHistory.desiredUpdatedDate!, currentFormat: "YYYY-MM-dd'T'HH:mm:ss", newDateFormat: "MMM d, yyyy HH:mm:ss")
        cell.lblDesierDate.text = strdesiredUpdatedDate
        cell.lblReport.text = objTwinPropertyHistory.reportedValue
        let strdReporteddDate = self.formatDate(strDate: objTwinPropertyHistory.reportedUpdatedDate!, currentFormat: "YYYY-MM-dd'T'HH:mm:ss", newDateFormat: "MMM d, yyyy HH:mm:ss")
        cell.lblReportDate.text = strdReporteddDate

        return cell
    }
    
    
}
