//
//  LoginVC.swift
//  EBV-IoT
//
//  Created by Milan Patel on 31/01/22.
//

import UIKit
import SkyFloatingLabelTextField

import SideMenu

class LoginVC: UIViewController
{
    var iconClick = true
    @IBOutlet var vwBox: UIView!
    @IBOutlet var imgPassView: UIImageView!
    @IBOutlet var txtUserName: SkyFloatingLabelTextField!
    @IBOutlet var txtPass: SkyFloatingLabelTextField!
    
    @IBOutlet var lblTitle: UILabel!
    @IBOutlet var lblNewuser: UILabel!
    @IBOutlet var lblLine: UILabel!
    @IBOutlet var btnSignup: UIButton!

    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        if UserDefaultManager.shared[.isRootLogin] != nil {
            if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                self.lblTitle.text = "Login"
                self.lblNewuser.isHidden = false
                self.lblLine.isHidden = false
                self.btnSignup.isHidden = false
                self.txtUserName.placeholder = "Email Address"
                self.txtUserName.title = "Email Address"
                self.txtPass.placeholder = "Password"
                self.txtPass.title = "Password"
            } else {
                self.lblTitle.text = "Root User Login"
                self.lblNewuser.isHidden = true
                self.lblLine.isHidden = true
                self.btnSignup.isHidden = true
                self.txtUserName.placeholder = "Root Email Address"
                self.txtUserName.title = "Root Email Address"
                self.txtPass.placeholder = "Root Password"
                self.txtPass.title = "Root Password"
            }
        } else {
            self.lblTitle.text = "Root User Login"
            self.lblNewuser.isHidden = true
            self.lblLine.isHidden = true
            self.btnSignup.isHidden = true
            self.txtUserName.placeholder = "Root Email Address"
            self.txtUserName.title = "Root Email Address"
            self.txtPass.placeholder = "Root Password"
            self.txtPass.title = "Root Password"
        }

        
        //User Details
        
        let objRightView = UIView(frame: CGRect(x: 0, y: 0, width: 30, height: 45))
        self.txtUserName.rightViewMode = .always
        objRightView.backgroundColor = .clear
        self.txtUserName.rightView = objRightView
        
        let objRightView1 = UIView(frame: CGRect(x: 0, y: 0, width: 30, height: 45))
        self.txtPass.rightViewMode = .always
        objRightView1.backgroundColor = .clear
        self.txtPass.rightView = objRightView1

//        self.txtUserName.text = "rumit.khakhi@softwebsolutions.com"
//        self.txtPass.text = "@Abcdefg8"
        
//        self.txtUserName.text = "ebv.test@yopmail.com"
//        self.txtPass.text = "Softweb#123"
    }
    
    override func viewWillAppear(_ animated: Bool) {
        print("viewwillapper")
        Constant.AppUtility.lockOrientation(.portrait)
        self.sideMenuController()?.sideMenu?.allowPanGesture = false
        self.sideMenuController()?.sideMenu?.allowRightSwipe = false
        self.sideMenuController()?.sideMenu?.hideSideMenu()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated) // No need for semicolon
        
        Constant.AppUtility.lockOrientation(.portrait)
    }
    
    override var supportedInterfaceOrientations: UIInterfaceOrientationMask {
        return .portrait
    }


    // MARK: - Button Actions
    @IBAction func btnClickPasswordView(sender: UIButton){
        if(iconClick == true)
        {
            self.txtPass.isSecureTextEntry = false
            self.imgPassView.image = UIImage(named: "passwordview_icon")
        }
        else
        {
            self.txtPass.isSecureTextEntry = true
            self.imgPassView.image = UIImage(named: "password_icon")
        }
        iconClick = !iconClick
    }
    
    @IBAction func btnClickConnect(sender: UIButton){
        let steusername = self.txtUserName.text?.trim()
        if UserDefaultManager.shared[.isRootLogin] != nil {
            if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                if steusername?.count == 0{
                    AlertConstant.showAlertMessage(self, Message: MessageConstant.commonMessage.enterUserName)
                    return
                } else if !AlertConstant.isValidEmail(steusername ?? ""){
                    AlertConstant.showAlertMessage(self, Message: MessageConstant.commonMessage.emailValid)
                    return
                } else if self.txtPass.text!.count == 0{
                    AlertConstant.showAlertMessage(self, Message: MessageConstant.commonMessage.enterPassword)
                    return
                }
            } else {
                if steusername?.count == 0{
                    AlertConstant.showAlertMessage(self, Message: "Please enter the root email address")
                    return
                }
                else if !AlertConstant.isValidEmail(steusername ?? ""){
                    AlertConstant.showAlertMessage(self, Message: "Please enter the valid root email address")
                    return
                }
                else if self.txtPass.text!.count == 0 {
                    AlertConstant.showAlertMessage(self, Message: "Please enter the root password")
                    return
                }
            }
        } else {
            if steusername?.count == 0{
                AlertConstant.showAlertMessage(self, Message: "Please enter the root email address")
                return
            }
            else if !AlertConstant.isValidEmail(steusername ?? ""){
                AlertConstant.showAlertMessage(self, Message: "Please enter the valid root email address")
                return
            }
            else if self.txtPass.text!.count == 0 {
                AlertConstant.showAlertMessage(self, Message: "Please enter the root password")
                return
            }
        }
        
        self.view.endEditing(true)
        if Constant.appDelegate.isConnectedToNetwork(){
            print("Internet Connection Available!")
            ProHudManager.shared.show(view: self.view, animated: true)
            if UserDefaultManager.shared[.basictoken] == nil {
                self.callBasicToken()
            } else {
                self.callLoginWebService()
            }
        }else{
            print("Internet Connection not Available!")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
        }
    }
    
    @IBAction func btnClickSignUp(sender: UIButton)
    {
        let objSignup = UIStoryboard(name: Constant.StoryboardIdentifier.signup, bundle: nil).instantiateViewController(withIdentifier: "SignupVC") as! SignupVC
        objSignup.strRootUser = UserDefaultManager.shared[.rootemail] as? String
        objSignup.strRootPass = UserDefaultManager.shared[.rootpass] as? String
        self.navigationController?.pushViewController(objSignup, animated: true)

//        self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.signup, bundle: nil).instantiateViewController(withIdentifier: "SignupVC"), animated: true)
    }
    
    // MARK: - BasicToken Web-Service
    func callBasicToken()
    {
//        ProHudManager.shared.show(view: self.view, animated: true)
        let dict : [String : Any] = [:]
        AuthenticationManager.shared.basicToken(paramers: dict ,successBlock: { (response) in
            print(response)
            let decoder = JSONDecoder()
            let basicToken = try? decoder.decode(BasicToken.self, from: response)
            UserDefaultManager.shared[.basictoken] = (basicToken!.data! as String)
            self.callLoginWebService()
        }, failureBlock: { error in
            print("\n\n===========Error===========")
            print("Error Code: \(error._code)")
            print("Error Messsage: \(error.localizedDescription)")
            ProHudManager.shared.hide(animated: true)
        })
    }
    
    // MARK: - Login Web-Service
    func callLoginWebService(){
        DispatchQueue.main.async {
          // your code here
            let param = [Constant.RequestConstant.email:self.txtUserName.text ?? "".trimmingCharacters(in: .whitespacesAndNewlines),Constant.RequestConstant.password:self.txtPass.text ?? "".trimmingCharacters(in: .whitespacesAndNewlines)] as [String : Any]
            AuthenticationManager.shared.loginWebService(paramers: param ,successBlock: { (response) in
                let decoder = JSONDecoder()
                let login = try? decoder.decode(LoginData.self, from: response)
                if login != nil
                {
                    print("----  Access Token ---- \((login?.access_token!)! as String)")
                    if UserDefaultManager.shared[.isRootLogin] != nil {
                        if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                            UserDefaultManager.shared[.accesstoken] = ((login?.access_token!)! as String)
                            UserDefaultManager.shared[.refreshtoken] = ((login?.refresh_token!)! as String)
                        } else {
                            UserDefaultManager.shared[.rootaccesstoken] = ((login?.access_token!)! as String)
                            UserDefaultManager.shared[.rootrefreshtoken] = ((login?.refresh_token!)! as String)
                        }
                    } else {
                        UserDefaultManager.shared[.rootaccesstoken] = ((login?.access_token!)! as String)
                        UserDefaultManager.shared[.rootrefreshtoken] = ((login?.refresh_token!)! as String)
                    }
//                    UserDefaultManager.shared[.accesstoken] = ((login?.access_token!)! as String)
//                    UserDefaultManager.shared[.refreshtoken] = ((login?.refresh_token!)! as String)
                    self.callUserInfo()
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
                if ((error as! EBVHttpErrors).errorDescription == "solution not found.") {
                    AlertConstant.showAlertMessage(self, Message: "Your subscription plan has been expired.")
                } else {
                    AlertConstant.showAlertMessage(self, Message: (error as! EBVHttpErrors).errorDescription)
                }
            })
        }
    }
    
    // MARK: - DeviceLists Web-Service
    func callUserInfo()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            AuthenticationManager.shared.getUserDetail(paramers: dict ,successBlock: { (response) in
                print(response)
                let decoder = JSONDecoder()
                let userDetail = try? decoder.decode(LoginDetail.self, from: response)
                if userDetail != nil
                {
                    DispatchQueue.main.async{
                        
                        if UserDefaultManager.shared[.isRootLogin] != nil {
                            if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                                UserDefaultManager.shared[.firstname] = ((userDetail?.data?.firstName)! as String)
                                UserDefaultManager.shared[.lastname] = ((userDetail?.data?.lastName)! as String)
                                UserDefaultManager.shared[.cpId] = ((userDetail?.data?.cpId)! as String)
                                UserDefaultManager.shared[.entityGuid] = ((userDetail?.data?.entityGuid)! as String)
                                UserDefaultManager.shared[.companyGuid] = ((userDetail?.data?.companyGuid)! as String)
                                UserDefaultManager.shared[.email] = self.txtUserName.text
                                UserDefaultManager.shared[.password] = self.txtPass.text
                                UserDefaultManager.shared[.userGuid] = userDetail?.data?.userGuid
                                UserDefaultManager.shared[.parentEntityGuid] = userDetail?.data?.parentEntityGuid

                                //Set Login user name
                                let objSideMenuController = self.sideMenuController()?.sideMenu?.menuViewController as! SideMenuViewController
                                objSideMenuController.lbl_username.text = String(format: "%@ %@", ((userDetail?.data?.firstName)! as String),((userDetail?.data?.lastName)! as String))
                                self.callDeviceLists()
                            } else {
                                let iscompadmin = userDetail?.data?.isCompanyAdmin
                                if (iscompadmin! && (userDetail?.data?.parentEntityGuid == nil || userDetail?.data?.parentEntityGuid == "")) {
                                    UserDefaultManager.shared[.rootemail] = userDetail?.data?.userId
                                    UserDefaultManager.shared[.rootpass] = self.txtPass.text
                                    UserDefaultManager.shared[.rootentityGuid] = ((userDetail?.data?.entityGuid)! as String)

                                    UserDefaultManager.shared[.isRootLogin] = true
                                    DispatchQueue.main.async {
                                    ProHudManager.shared.hide(animated: true)
                                    self.lblTitle.text = "Login"
                                    self.lblNewuser.isHidden = false
                                    self.lblLine.isHidden = false
                                    self.btnSignup.isHidden = false
                                    self.txtUserName.placeholder = "Email Address"
                                    self.txtUserName.title = "Email Address"
                                    self.txtPass.placeholder = "Password"
                                    self.txtPass.title = "Password"
                                    self.txtUserName.text = ""
                                    self.txtPass.text = ""
                                    let transition = CATransition()
                                    transition.type = CATransitionType.push
                                    transition.subtype = .fromRight
                                    self.view.layer.add(transition, forKey: nil)
                                    }
                                } else {
                                    ProHudManager.shared.hide(animated: true)
                                    AlertConstant.showAlertMessage(self, Message: "Root Email Address is not valid")
                                }
                            }
                        } else {
                            let iscompadmin = userDetail?.data?.isCompanyAdmin
                            if (iscompadmin! && (userDetail?.data?.parentEntityGuid == nil || userDetail?.data?.parentEntityGuid == "")) {
                                UserDefaultManager.shared[.rootemail] = userDetail?.data?.userId
                                UserDefaultManager.shared[.rootpass] = self.txtPass.text
                                UserDefaultManager.shared[.rootentityGuid] = ((userDetail?.data?.entityGuid)! as String)

                                UserDefaultManager.shared[.isRootLogin] = true
                                DispatchQueue.main.async {
                                ProHudManager.shared.hide(animated: true)
                                self.lblTitle.text = "Login"
                                self.lblNewuser.isHidden = false
                                self.lblLine.isHidden = false
                                self.btnSignup.isHidden = false
                                self.txtUserName.placeholder = "Email Address"
                                self.txtUserName.title = "Email Address"
                                self.txtPass.placeholder = "Password"
                                self.txtPass.title = "Password"
                                self.txtUserName.text = ""
                                self.txtPass.text = ""
                                let transition = CATransition()
                                transition.type = CATransitionType.push
                                transition.subtype = .fromRight
                                self.view.layer.add(transition, forKey: nil)
                                }
                            } else {
                                ProHudManager.shared.hide(animated: true)
                                AlertConstant.showAlertMessage(self, Message: "Root Email Address is not valid")
                            }
                        }
                    }
               }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
    
    // MARK: - DeviceLists Web-Service
    func callDeviceLists()
    {
        DispatchQueue.main.async {
            let param = [Constant.RequestConstant.pageindex:1,            Constant.RequestConstant.pagesize:Constant.k_PAGE_SIZE] as           [String : Any]
            DeviceManager.shared.deviceListsWebService(paramers: param ,successBlock: { (response) in
                ProHudManager.shared.hide(animated: true)
                print(response)
                let decoder = JSONDecoder()
                let devicelists = try? decoder.decode(Devices.self, from: response)
                if devicelists != nil{
                    DispatchQueue.main.async
                    {
                        UserDefaultManager.shared[.isLogin] = true
                        if devicelists!.count > 0
                        {
                            UserDefaultManager.shared[.deviceAdded] = true
                            let mainStoryboard: UIStoryboard = UIStoryboard(name: Constant.StoryboardIdentifier.device,bundle: nil)
                            let destViewController = mainStoryboard.instantiateViewController(withIdentifier: "DeviceVC")
                            self.sideMenuController()?.setContentViewController(destViewController)
                        }
                        else
                        {
                            UserDefaultManager.shared[.deviceAdded] = false
                            let mainStoryboard: UIStoryboard = UIStoryboard(name: Constant.StoryboardIdentifier.device,bundle: nil)
                            let destViewController = mainStoryboard.instantiateViewController(withIdentifier: "AddDeviceVC")
                            self.sideMenuController()?.setContentViewController(destViewController)
                        }
                    }
                }
                else
                {
                    DispatchQueue.main.async
                    {
                        let mainStoryboard: UIStoryboard = UIStoryboard(name: Constant.StoryboardIdentifier.device,bundle: nil)
                        let destViewController = mainStoryboard.instantiateViewController(withIdentifier: "AddDeviceVC")
                        self.sideMenuController()?.setContentViewController(destViewController)
                    }
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
           
    // This will notify us when something has changed on the textfield
    @objc func textFieldDidChange(_ textfield: UITextField)
    {
       if let text = textfield.text
       {
           if let floatingLabelTextField = textfield as? SkyFloatingLabelTextField {
               if(text.count < 3 || !text.contains("@")) {
                   floatingLabelTextField.errorMessage = "Invalid email"
               }
               else {
                   // The error message will only disappear when we reset it to nil or empty string
                   floatingLabelTextField.errorMessage = ""
               }
           }
        }
    }

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}

extension String
{
    func trim() -> String
   {
     return self.trimmingCharacters(in: NSCharacterSet.whitespaces)
   }
}

