//
//  SignupVC.swift
//  EBV-IoT
//
//  Created by Milan Patel on 31/01/22.
//

import UIKit
import SkyFloatingLabelTextField

class SignupVC: UIViewController,UIPickerViewDelegate,UIPickerViewDataSource {
    

    @IBOutlet weak var viewTop: UIView!
    var arrCountryList : [CountryInfo] = [CountryInfo]()
    var arrStateList : [StateInfo] = [StateInfo]()
    var filteredCodeList = [Country]()
    
    private var arrCountryCodeList: [Country] {
        let countries = Countries()
        let countryList = countries.countries
        return countryList
    }
    
    @IBOutlet var txtrootUserName: SkyFloatingLabelTextField!
    @IBOutlet var txtrootPassword: SkyFloatingLabelTextField!
    @IBOutlet var txtfirstName: SkyFloatingLabelTextField!
    @IBOutlet var txtlastName: SkyFloatingLabelTextField!
    @IBOutlet var txtUserid: SkyFloatingLabelTextField!
    @IBOutlet var txtPassword: SkyFloatingLabelTextField!
    @IBOutlet var txtConfirmPassword: SkyFloatingLabelTextField!
    @IBOutlet var txtaddress: SkyFloatingLabelTextField!
    @IBOutlet var txtContactExt: SkyFloatingLabelTextField!
    @IBOutlet var txtContact: SkyFloatingLabelTextField!
    @IBOutlet var txtCountry: SkyFloatingLabelTextField!
    @IBOutlet var txtState: SkyFloatingLabelTextField!
    @IBOutlet var txtCity: SkyFloatingLabelTextField!
    @IBOutlet var txtPostalcode: SkyFloatingLabelTextField!

    var strRootUser: String! = ""
    var strRootPass : String! = ""
    var strEntityGuid : String! = ""
    var strRoleGuid : String! = ""
    var strCountryGuid : String! = ""
    var strStateGuid : String! = ""
    var strcountrycode : String! = ""

    @IBOutlet  var viewPicker: UIView!
    @IBOutlet  var pickerview: UIPickerView!
    @IBOutlet  var toolbar: UIToolbar!
    @IBOutlet  var barbuttoncancel: UIBarButtonItem!
    @IBOutlet  var barbuttondone: UIBarButtonItem!
    var selectedPickerIndex : Int = 0
    var selectedRow : Int = 0
    @IBOutlet  var btnCountry: UIButton!
    @IBOutlet  var btnState: UIButton!
    
    var selectedExt : String = "+1"

    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.viewPicker.isHidden = true
        self.pickerview.isHidden = true

        // Do any additional setup after loading the view.
//        self.txtrootUserName.text = "ebv.softwebdev@mailinator.com"
//        self.txtrootPassword.text = "Softweb#123"
        self.txtContactExt.text = "US (+1)"
        viewTop.layer.cornerRadius = 15
        viewTop.layer.maskedCorners = [.layerMinXMaxYCorner, .layerMaxXMaxYCorner]
        viewTop.clipsToBounds = true
        
        self.btnState.isUserInteractionEnabled = false
        self.callCountryLists()
    }
    
    // MARK: - PickerView Delegate
    func numberOfComponents(in pickerView: UIPickerView) -> Int {
        return 1
    }
    
    func pickerView(_ pickerView: UIPickerView, numberOfRowsInComponent component: Int) -> Int {
        if selectedPickerIndex == 1{
            return self.arrCountryList.count
        } else if selectedPickerIndex == 2{
            return self.arrStateList.count
        }
        else if selectedPickerIndex == 3{
            return arrCountryCodeList.count
        }
        return 10
    }
    
    func pickerView(_ pickerView: UIPickerView, titleForRow row: Int, forComponent component: Int) -> String? {
        if selectedPickerIndex == 1{
            return self.arrCountryList[row].name
        } else if selectedPickerIndex == 2{
            return self.arrStateList[row].name
        } else if selectedPickerIndex == 3{
            return String(format: "%@ (+%@)", self.arrCountryCodeList[row].countryCode,self.arrCountryCodeList[row].phoneExtension)
        }

        return ""
    }
    
    func pickerView(_ pickerView: UIPickerView, didSelectRow row: Int, inComponent component: Int)
    {
        selectedRow = row
//        if selectedPickerIndex == 1{
//            self.txtCountry.text = self.arrCountryList[row].name
//        } else if selectedPickerIndex == 2{
//            self.txtState.text = self.arrStateList[row].name
//        } else if selectedPickerIndex == 3{
//            self.txtContactExt.text = String(format: "%@ (+%@)", self.arrCountryCodeList[row].countryCode,self.arrCountryCodeList[row].phoneExtension)
//        }
    }

    // MARK: - CountryLists Web-Service
    func callCountryLists()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            AuthenticationManager.shared.getCountryList(paramers: dict ,successBlock: { (response) in
                print(response)
                let decoder = JSONDecoder()
                let countrylists = try? decoder.decode(CountryList.self, from: response)
                if countrylists != nil
                {
                    DispatchQueue.main.async
                    {
                        self.arrCountryList = (countrylists?.data)!
                    }
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
    
    // MARK: - StateLists Web-Service
    func callStateLists()
    {
        DispatchQueue.main.async {
            self.strStateGuid = ""
            self.txtState.text = ""
            if self.arrStateList.count > 0{
                self.arrStateList.removeAll()
            }
            
            let param = [Constant.RequestConstant.countryGuid:self.strCountryGuid ?? ""] as [String : Any]
            AuthenticationManager.shared.getStateList(paramers: param ,successBlock: { (response) in
                ProHudManager.shared.hide(animated: true)
                print(response)
                let decoder = JSONDecoder()
                let statelists = try? decoder.decode(StateLists.self, from: response)
                if statelists != nil
                {
                    print(statelists?.data as Any)
                    self.arrStateList = (statelists?.data)!
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }

    // MARK: - BasicToken Web-Service
    func callBasicToken()
    {
        ProHudManager.shared.show(view: self.view, animated: true)
        let dict : [String : Any] = [:]
        AuthenticationManager.shared.basicToken(paramers: dict ,successBlock: { (response) in
            print(response)
            let decoder = JSONDecoder()
            let basicToken = try? decoder.decode(BasicToken.self, from: response)
            UserDefaultManager.shared[.basictoken] = (basicToken!.data! as String)
            self.callLoginWebService()
        }, failureBlock: { error in
            print("\n\n===========Error===========")
            print("Error Code: \(error._code)")
            print("Error Messsage: \(error.localizedDescription)")
            ProHudManager.shared.hide(animated: true)
        })
    }
    
    // MARK: - Login Web-Service
    func callLoginWebService(){
        DispatchQueue.main.async {
          // your code here
            let param = [Constant.RequestConstant.email:self.strRootUser ?? "",Constant.RequestConstant.password:self.strRootPass ?? ""] as [String : Any]
            AuthenticationManager.shared.loginWebService(paramers: param ,successBlock: { (response) in
                let decoder = JSONDecoder()
                let login = try? decoder.decode(LoginData.self, from: response)
                if login != nil
                {
                    print("----  Access Token ---- \((login?.access_token!)! as String)")
                    UserDefaultManager.shared[.accesstoken] = ((login?.access_token!)! as String)
                    self.callEntityLists()
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }

    // MARK: - EntityList Web-Service
    func callEntityLists()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            AuthenticationManager.shared.getEntityList(paramers: dict ,successBlock: { (response) in
                print(response)
                let decoder = JSONDecoder()
                let entitylists = try? decoder.decode(EntityList.self, from: response)
                if entitylists != nil
                {
                    DispatchQueue.main.async
                    { [self] in
                        var arr_filter_entity : [EntityInfo] = [EntityInfo]()
                        arr_filter_entity = (entitylists?.data!.filter{$0.parentEntityGuid == nil})!
                        if arr_filter_entity.count > 0 {
                            strEntityGuid = arr_filter_entity[0].guid
                        }
                        self.callRoleLists()
                    }
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
    
    // MARK: - RoleList Web-Service
    func callRoleLists()
    {
        DispatchQueue.main.async {
            let dict : [String : Any] = [:]
            AuthenticationManager.shared.getRoleList(paramers: dict ,successBlock: { (response) in
                print(response)
                let decoder = JSONDecoder()
                let rolelists = try? decoder.decode(RoleList.self, from: response)
                if rolelists != nil
                {
                    DispatchQueue.main.async
                    { [self] in
                        var arr_filter_role : [RoleInfo] = [RoleInfo]()
                        arr_filter_role = (rolelists?.data!.filter{$0.description == "Mobile User" || $0.description == "mobile user"})!
                        if arr_filter_role.count > 0 {
                            
                            strRoleGuid = arr_filter_role[0].guid
                            //Call webservice to adduser
                            self.callAddUser()
                        }
                        else
                        {
                            //Call webservice to create role
                            self.callCreateRole()
                        }
                    }
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
            })
        }
    }
    
    // MARK: - SignUP Web-Service
    func callAddUser()
    {
        DispatchQueue.main.async
        { [self] in
            var strContact = ""
            if self.txtContact.text?.count != 0{
                self.selectedExt = self.selectedExt.replacingOccurrences(of: "+", with: "", options: [.anchored], range: nil)
                strContact = "\(self.selectedExt)-\(self.txtContact.text ?? "")"
            } else {
                strContact = ""
            }
            let userinfo = [Constant.RequestConstant.firstName:self.txtfirstName.text ?? "",Constant.RequestConstant.lastName:self.txtlastName.text ?? "",Constant.RequestConstant.userId:self.txtUserid.text ?? "",Constant.RequestConstant.timezoneGuid:"E39F8004-31BC-42CE-B97A-C0668BD1F965",Constant.RequestConstant.roleGuid:self.strRoleGuid ?? "",Constant.RequestConstant.contactNo:strContact,Constant.RequestConstant.isActive:true,Constant.RequestConstant.sendInvitationEmail:false,Constant.RequestConstant.isTempPassword:false,Constant.RequestConstant.newUserpassword:self.txtPassword.text ?? ""] as [String : Any]
            
//            let name = String(format: "%@ %@", self.txtfirstName.text ?? "",self.txtlastName.text ?? "")
            let param = [Constant.RequestConstant.name:self.txtUserid.text ?? "" ,Constant.RequestConstant.parentEntityGuid:self.strEntityGuid ?? "",Constant.RequestConstant.address:self.txtaddress.text ?? "",Constant.RequestConstant.city:self.txtCity.text ?? "",Constant.RequestConstant.stateGuid:self.strStateGuid ?? "",Constant.RequestConstant.countryGuid:self.strCountryGuid ?? "",Constant.RequestConstant.zipCode:self.txtPostalcode.text ?? "",Constant.RequestConstant.timezoneGuid:"E39F8004-31BC-42CE-B97A-C0668BD1F965",Constant.RequestConstant.userInfo:userinfo] as [String : Any]
            AuthenticationManager.shared.SignupWebService(paramers: param ,successBlock: { (response) in
                ProHudManager.shared.hide(animated: true)
                print(response)
                let decoder = JSONDecoder()
                let signUp = try? decoder.decode(SignUPModel.self, from: response)
                if signUp != nil
                {
                    DispatchQueue.main.async {
                    let alertController = UIAlertController(title:APP_NAME, message: "User has been successfully added.", preferredStyle: UIAlertController.Style.alert)
                    alertController.view.tintColor = UIColor.black
                    alertController.addAction(UIAlertAction(title: "OK", style: UIAlertAction.Style.default, handler: { alert in
                        self.navigationController?.popViewController(animated: true)
                    
                    }))
                    self.present(alertController, animated: true, completion: nil)
                    }
//                    AlertConstant.showAlertMessage(self, Message: "User has been successfully added.")
                }
            }, failureBlock: { error in
                print("\n\n===========Error===========")
                print("Error Code: \(error._code)")
                print("Error Messsage: \(error.localizedDescription)")
                ProHudManager.shared.hide(animated: true)
                AlertConstant.showAlertMessage(self, Message: (error as! EBVHttpErrors).errorDescription)
            })
        }
    }

    // MARK: - Create Role list

        func callCreateRole()
        {
            DispatchQueue.main.async {

                var dict : [String : Any] = [:]
                dict["name"] = Constant.USER_ROLE
                dict["description"] = Constant.USER_ROLE
                dict["solutions"] = [Constant.Client_ID]

                AuthenticationManager.shared.createRole(paramers: dict ,successBlock: { (response) in

                    print(response)
                    let decoder = JSONDecoder()
                    let response = try? decoder.decode(CreateRole.self, from: response)
                    if response != nil

                    {
                        print("Response Code: \(String(describing: response?.status))")
                        print("Response Message: \(String(describing: response?.message))")

                        if response?.data.count != 0
                        {
                            self.strRoleGuid = response?.data[0].newID
                            self.callAddUser()
                        }

                    }

                }, failureBlock: { error in

                    print("\n\n===========Error===========")
                    print("Error Code: \(error._code)")
                    print("Error Messsage: \(error.localizedDescription)")
                    ProHudManager.shared.hide(animated: true)

                })

            }

        }
    // MARK: - Button Actions
    @IBAction func btnClickCancel(sender: UIButton){
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func btnClickSubmit(sender: UIButton) {
        
//        if self.txtrootUserName.text!.count == 0{
//            AlertConstant.showAlertMessage(self, Message: "Please enter the root email address")
//            return
//        }
//        else if !AlertConstant.isValidEmail(self.txtrootUserName.text!){
//            AlertConstant.showAlertMessage(self, Message: "Please enter the valid root email address")
//            return
//        }
//        else if self.txtrootPassword.text!.count == 0 {
//            AlertConstant.showAlertMessage(self, Message: "Please enter the root password")
//            return
//        }
        if self.txtfirstName.text!.count == 0 {
            AlertConstant.showAlertMessage(self, Message: "Please enter the firstname")
            return
        }
        else if self.txtlastName.text!.count == 0{
            AlertConstant.showAlertMessage(self, Message: "Please enter the lastname")
            return
        }
        else if self.txtUserid.text!.count == 0{
            AlertConstant.showAlertMessage(self, Message: "Please enter the email address")
            return
        }
       else if !AlertConstant.isValidEmail(self.txtUserid.text!){
            AlertConstant.showAlertMessage(self, Message: "Please enter the valid email address")
            return
        }
        else if self.txtPassword.text!.count == 0{
            AlertConstant.showAlertMessage(self, Message: "Please enter the password")
            return
        }
        else if !AlertConstant.isValidPassword(self.txtPassword.text!){
             AlertConstant.showAlertMessage(self, Message: "Password should be at least 8 characters long and contain a combination of upper and lower case alphabets, special character and number")
             return
         }
        else if self.txtConfirmPassword.text!.count == 0{
            AlertConstant.showAlertMessage(self, Message: "Please enter the confirm password")
            return
        }
        else if self.txtPassword.text != self.txtConfirmPassword.text{
            AlertConstant.showAlertMessage(self, Message: "Your password and confirmation password do not match")
            return
        }
        
        self.view.endEditing(true)
        if Constant.appDelegate.isConnectedToNetwork(){
            print("Internet Connection Available!")
            ProHudManager.shared.show(view: self.view, animated: true)
            self.callEntityLists()
//
//            self.callBasicToken()
        }else{
            print("Internet Connection not Available!")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
        }
    }

    @IBAction func btnPcker(sender: UIButton)
    {
        selectedPickerIndex = sender.tag
        
        if selectedPickerIndex == 1 {
            if self.arrCountryList.count > 0 {
                self.pickerview.selectRow(0, inComponent:0, animated:true)
            }
        } else if selectedPickerIndex == 2 {
            if self.arrStateList.count > 0 {
                self.pickerview.selectRow(0, inComponent:0, animated:true)
            }
        } else if selectedPickerIndex == 3 {
            if self.arrCountryCodeList.count > 0 {
                self.pickerview.selectRow(0, inComponent:0, animated:true)
            }
        }
        if self.viewPicker.isHidden == true{
            self.viewPicker.isHidden = false
            self.pickerview.isHidden = false
            self.pickerview.reloadAllComponents()
            selectedRow = 0
            //Set scrollview frame
            UIView.animate(withDuration: 0.5,
                           delay: 0.0,
                           options: UIView.AnimationOptions.curveEaseIn,
                           animations: { () -> Void in
                            
                            self.viewPicker.frame = CGRect(origin: CGPoint(x: 0.0, y: (self.view.frame.size.height - self.viewPicker.frame.size.height) ), size: CGSize(width: self.viewPicker.frame.size.width, height:self.viewPicker.frame.size.height))
                            
                           }, completion: { (finished) -> Void in
                            
                           })
        }
    }
    
    @IBAction func barClickCancel(_ sender: AnyObject)    {
        self.viewPicker.isHidden = true
    }

    @IBAction func barClickDone(_ sender: AnyObject)    {
        if selectedPickerIndex == 1
        {
            if self.arrCountryList.count > 0 {
                self.btnState.isUserInteractionEnabled = true
                self.strCountryGuid = self.arrCountryList[selectedRow].guid
                ProHudManager.shared.show(view: self.view, animated: true)
                self.txtCountry.text = self.arrCountryList[selectedRow].name
                let arr_filter_code = (self.arrCountryCodeList.filter{$0.countryCode == self.arrCountryList[selectedRow].countryCode})
                print(arr_filter_code)
                if arr_filter_code.count > 0
                {
                    self.txtContactExt.text = String(format: "%@ (+%@)", arr_filter_code[0].countryCode,arr_filter_code[0].phoneExtension)
                }
                self.callStateLists()
            }
        }
        else if selectedPickerIndex == 2
        {
            if self.arrCountryList.count > 0 {
                self.strStateGuid = self.arrStateList[selectedRow].guid
                self.txtState.text = self.arrStateList[selectedRow].name
            }
        } else {
            if self.arrCountryCodeList.count > 0 {
                self.txtContactExt.text = String(format: "%@ (+%@)", self.arrCountryCodeList[selectedRow].countryCode,self.arrCountryCodeList[selectedRow].phoneExtension)
                self.selectedExt = self.arrCountryCodeList[selectedRow].phoneExtension
            }
        }

        self.viewPicker.isHidden = true
    }
    
    @IBAction func btnShowHideRootPasswordClick(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
        txtrootPassword.isSecureTextEntry = !txtrootPassword.isSecureTextEntry
    }
    
    @IBAction func btnShowHidePasswordClick(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
        txtPassword.isSecureTextEntry = !txtPassword.isSecureTextEntry
    }
    
    @IBAction func btnShowHideConfirmPasswordClick(_ sender: UIButton) {
        sender.isSelected = !sender.isSelected
        txtConfirmPassword.isSecureTextEntry = !txtConfirmPassword.isSecureTextEntry
//        if sender.isSelected == true{
//            txtConfirmPassword.isSecureTextEntry = false
//        } else {
//            txtConfirmPassword.isSecureTextEntry = true
//
//        }
    }

    
}
