//
//  SplashVC.swift
//  EBV-IoT
//
//  Created by Milan Patel on 31/01/22.
//

import UIKit

class SplashVC: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()

        self.sideMenuController()?.sideMenu?.allowPanGesture = false
        self.sideMenuController()?.sideMenu?.allowRightSwipe = false
        self.setloginscreen()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated) // No need for semicolon
        
        Constant.AppUtility.lockOrientation(.portrait)
    }
    
    override func viewWillAppear(_ animated: Bool) {
        print("viewwillapper")
        Constant.AppUtility.lockOrientation(.portrait)
    }

    func setloginscreen()
    {
        if UserDefaultManager.shared[.isRootLogin] != nil {
            if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                self.setGotoLogin_Device()
            }
            else {
                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
            }
        } else {
            self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
        }
        /*return
        
        if UserDefaultManager.shared[.isLogin] != nil {
            if (UserDefaultManager.shared[.isLogin] as! Bool) {
                if Constant.appDelegate.isConnectedToNetwork(){
                    print("Internet Connection Available!")
                    self.call_refreshToken()
                }else{
                    print("Internet Connection not Available!")
                    ProHudManager.shared.hide(animated: true)
                    AlertConstant.showAlertMessage(self, Message: "No network available. Please check your Wifi or Data connections")
                }
            } else {
                if UserDefaultManager.shared[.isRootLogin] != nil {
                    if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                        self.call_rootrefreshToken()
                    } else {
                        self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
                    }
                }
                else {
                    self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
                }
            }
        } else {
            if UserDefaultManager.shared[.isRootLogin] != nil {
                if (UserDefaultManager.shared[.isRootLogin] as! Bool) {
                    self.call_rootrefreshToken()
                } else {
                    self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
                }
            }
            else {
                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
            }
        }*/
    }
    
    func setGotoLogin_Device()
    {
        if UserDefaultManager.shared[.isLogin] != nil {
            if (UserDefaultManager.shared[.isLogin] as! Bool) {
                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DeviceVC"), animated: true)
            }
            else {
                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
            }
        } else {
            self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
        }
    }
    
    func call_refreshToken() {
        let param = [Constant.RequestConstant.refreshtoken:UserDefaultManager.shared[.refreshtoken] ?? ""] as [String : Any]
        AuthenticationManager.shared.refreshToken(paramers: param ,successBlock: { (response) in
            do {
                if let json = try JSONSerialization.jsonObject(with: response, options: []) as? [String: Any] {
                    
                    UserDefaultManager.shared[.accesstoken] = json["access_token"]
                    UserDefaultManager.shared[.refreshtoken] = json["refresh_token"]
                    
                    self.call_rootrefreshToken()
                    
//                    DispatchQueue.main.async {
//                        if UserDefaultManager.shared[.deviceAdded] != nil {
//                            if (UserDefaultManager.shared[.deviceAdded] as! Bool) {
//                                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DeviceVC"), animated: true)
//                            } else {
//                                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "AddDeviceVC"), animated: true)
//                            }
//                        } else {
//                         self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DeviceVC"), animated: true)
//                        }
//                    }
                }
            } catch let error as NSError {
                print("Failed to load: \(error.localizedDescription)")
            }
        }, failureBlock: { error in
            print("\n\n===========Error===========")
            print("Error Code: \(error._code)")
            print("Error Messsage: \(error.localizedDescription)")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: (error as! EBVHttpErrors).errorDescription)
        })
    }
    
    func call_rootrefreshToken() {
        let param = [Constant.RequestConstant.refreshtoken:UserDefaultManager.shared[.rootrefreshtoken] ?? ""] as [String : Any]
        AuthenticationManager.shared.rootrefreshToken(paramers: param ,successBlock: { (response) in
            do {
                if let json = try JSONSerialization.jsonObject(with: response, options: []) as? [String: Any] {
                    
                    UserDefaultManager.shared[.rootaccesstoken] = json["access_token"]
                    UserDefaultManager.shared[.rootrefreshtoken] = json["refresh_token"]
                    
                    DispatchQueue.main.async {
                        self.callsetdevicescreen()
                    }
                }
            } catch let error as NSError {
                print("Failed to load: \(error.localizedDescription)")
            }
        }, failureBlock: { error in
            print("\n\n===========Error===========")
            print("Error Code: \(error._code)")
            print("Error Messsage: \(error.localizedDescription)")
            ProHudManager.shared.hide(animated: true)
            AlertConstant.showAlertMessage(self, Message: (error as! EBVHttpErrors).errorDescription)
        })
    }
    
    func callsetdevicescreen()
    {
        if UserDefaultManager.shared[.isLogin] != nil {
            if (UserDefaultManager.shared[.isLogin] as! Bool) {
                if UserDefaultManager.shared[.deviceAdded] != nil {
                    if (UserDefaultManager.shared[.deviceAdded] as! Bool) {
                        self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DeviceVC"), animated: true)
                    } else {
                        self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "AddDeviceVC"), animated: true)
                    }
                } else {
                     self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.device, bundle: nil).instantiateViewController(withIdentifier: "DeviceVC"), animated: true)
                }
            } else {
                self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
            }
        } else {
            self.navigationController?.pushViewController(UIStoryboard(name: Constant.StoryboardIdentifier.login, bundle: nil).instantiateViewController(withIdentifier: "LoginVC"), animated: true)
        }
    }
    

    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */
}
