//
//  UserSettingsVC.swift
//  EBV-IoT
//
//  Created by krutik vora on 07/02/22.
//

import UIKit

class UserSettingsVC: UIViewController {

    @IBOutlet weak var lblRootUserLogin: UILabel!
    @IBOutlet weak var lblUserLogin: UILabel!
    @IBOutlet weak var lblCPID: UILabel!
    @IBOutlet weak var lblBackendURL: UILabel!
    @IBOutlet weak var lblAppVersion: UILabel!
    @IBOutlet weak var viewTop: UIView!

    override func viewDidLoad() {
        super.viewDidLoad()
        viewTop.layer.cornerRadius = 15
        viewTop.layer.maskedCorners = [.layerMinXMaxYCorner, .layerMaxXMaxYCorner]
        viewTop.clipsToBounds = true

        lblRootUserLogin.text = (UserDefaultManager.shared[.rootemail] as! String)
        lblUserLogin.text = (UserDefaultManager.shared[.email] as! String)
        lblCPID.text = (UserDefaultManager.shared[.cpId] as! String)
        let appVersion = String(format: "%@ (%@)", Bundle.main.infoDictionary?["CFBundleShortVersionString"] as! String,Bundle.main.infoDictionary?["CFBundleVersion"] as! String)
        lblAppVersion.text = appVersion
        lblBackendURL.text = WebConstant.BASE_URL_USER
        lblCPID.adjustsFontSizeToFitWidth = true
        // Do any additional setup after loading the view.
    }
    
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated) // No need for semicolon
        
        Constant.AppUtility.lockOrientation(.portrait)
    }

    //MARK:- Button Action Event
        @IBAction func btnSideMEnuClick(sender : UIButton){
            toggleSideMenuView()
        }


    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destination.
        // Pass the selected object to the new view controller.
    }
    */

}
