//
//  ErrosLog.swift
//  IoTConnect
//
//  Created by PC4111 on 20/08/21.
//

import Foundation

enum EBVHttpErrors: Error {
    case unknownError
    case noInternetConnection
    case requestTimeout
    case invalidJson
    case unableToCreateRequest
    case emptyData
    case unacceptableStatusCode
    case unableToDecode
    case notFound
    case unAuthorized
    case forbidden
    case customError(String)

    var errorDescription: String {
        switch self {
        case .unknownError:          return "Unknown error"
        case .notFound:              return "Not found"
        case .noInternetConnection:  return "No internet connection"
        case .requestTimeout:        return "Request timeout"
        case .invalidJson:           return "Invalid json"
        case .unableToCreateRequest: return "Unable to create request"
        case .emptyData:             return "Empty data"
        case .unacceptableStatusCode:return "Unacceptable status code"
        case .unableToDecode:        return "Unable to decode json"
        case .unAuthorized:          return "unAuthorized User"
        case .forbidden:              return "forbidden"
        case .customError(let errMessage):
            return errMessage
        }
    }
}

struct Log {
    enum Info: String {
        case INFO_IN01 = "Device information received successfully"
    }
}
