//
//  Subscription.swift
//  EBV-IoT
//
//  Created by Milan Patel on 01/04/22.
//

import Foundation

struct Subscription {
    typealias CompletionHandler = (_ success:Bool) -> Void
    
    static let shared = Subscription()
    
    // MARK: - Subscription
    
//    func subscriptionWebService(paramers:[String:Any], successBlock:@escaping (Data) -> (), failureBlock: @escaping (Error) -> ()) {
//        let config = getRequestConfigSubscription(param: paramers,
//                                           endPointURL: WebConstant.SUBSCRIPTION_TOKEN_PATH,
//                                           method: .post)
//        HTTPService.shared.makeRequest(config: config, success: { (response) in
//            print("---- response ----  \(response)")
//            successBlock(response)
//        },failure: { error in
//            print("\n\n---- Error ----")
//            failureBlock(error)
//        })
//    }
//    
//    fileprivate func getRequestConfigSubscription(param:[String:Any],
//                                           endPointURL:String,
//                                           method:HTTPMethod) -> HTTPRequestConfig {
//        return HTTPRequestConfig(baseUrl: WebConstant.BASE_URL_SUBSCRIPTION,
//                                 path:WebConstant.SUBSCRIPTION_TOKEN_PATH,
//                                 body:param,
//                                 urlParams:nil,
//                                 method: .post)
//    }
    
    // MARK: - EnvironmentId
    
    func getEnvironmentId(paramers:[String:Any], successBlock:@escaping (Data) -> (), failureBlock: @escaping (Error) -> ()) {
        let strApp = String(format: "%@/%@", WebConstant.SUBSCRIPTION_ENVIORNMENT_PATH,paramers["compguid"] as! CVarArg)
        let config = getRequestConfigEnvironmentId(param: paramers,
                                                 endPointURL: strApp,
                                           method: .get)
        HTTPService.shared.makeRequestwithoutBody(config: config, success: { (response) in
            print("---- response ----  \(response)")
            successBlock(response)
        },failure: { error in
            print("\n\n---- Error ----")
            failureBlock(error)
        })
    }

    fileprivate func getRequestConfigEnvironmentId(param:[String:Any],
                                           endPointURL:String,
                                           method:HTTPMethod) -> HTTPRequestConfigwithoutBody {
        let strApp = String(format: "%@/%@", WebConstant.SUBSCRIPTION_ENVIORNMENT_PATH,param["compguid"] as! CVarArg)
        return HTTPRequestConfigwithoutBody(baseUrl: WebConstant.BASE_URL_SUBSCRIPTION,
                                            path:strApp,
                                 headers: [WebConstant.requestConstants.kAuthorization: "Bearer " + (UserDefaultManager.shared[.accesstokenSubscription] as! String)], method: .get)
    }
}
