## Introduction
The EBV-IoT – Infineon IoTConnect Secure Cloud connected solution is a powerful and innovative system that brings together the latest advancements in IoT technology and cloud connectivity to provide a highly secure and reliable platform for businesses looking to embrace the benefits of the Internet of Things. This solution offers a range of features and capabilities that make it ideal for a wide range of applications, from smart homes and buildings to industrial automation and beyond. With its advanced security features, real-time data analytics, and flexible deployment options, the EBV-IoT – Infineon IoTConnect Secure Cloud connected solution is poised to become one of the leading solutions in the fast-growing IoT market.

<img src="media/InfineonDemoFull.png" height="50%" />

The solution was developed using internal expertise from EBV Elektronik and is built on a foundation of advanced hardware and software components, including Infineon PSoC&trade; MCU, AIROC&trade; CYW43012 based muRata Type 1LV WiFi/BT combo module, XENSIV&trade; PAS CO2 and DPS310 pressure sensors using EBV internally developed PAS CO2 and OPTIGA&trade; Trust M evaluation shields, as well as the Avnet IoTConnect cloud platform.

The PAS CO2 evaluation shield is designed for seamless evaluation using standard hardware interface and to provide accurate and reliable CO2 monitoring for a wide range of applications, from indoor air quality monitoring to industrial automation. 

<img src="media/PASCO2EvSh.png" height="30%" />

Similarly, the OPTIGA&trade; Trust M evaluation shield simplifies access to advanced security features that are critical for ensuring the integrity and confidentiality of data transmitted over the IoT network. 

<img src="media/OTM-Full.png" height="30%" />

Finally, the Avnet IoTConnect cloud platform provides a highly scalable and flexible cloud infrastructure that enables the secure and efficient management of IoT devices and data. With its advanced analytics and visualization tools, as well as its powerful security features, the Avnet IoTConnect cloud platform is the perfect complement to the above hardware system.

This code is based on the [mtb-example-optiga-mqtt-client](https://github.com/Infineon/mtb-example-optiga-mqtt-client) project and
 uses [optiga_trust_helpers](https://github.com/Infineon/mtb-example-optiga-mqtt-client/blob/master/source/optiga_trust_helpers.c) files.
 
 Please contact you local **[EBV Elektronik](https://www.avnet.com/wps/portal/ebv/about-us/locations-contacts/)** representative or [ssc@ebv.com](mailto:ssc@ebv.com?subject=EBV-IoT%20–%20 Infineon%20IoTConnect%20Secure%20Cloud%20connected%20solution) for complete training manual.

## Requirements
- [ModusToolbox™ software](https://www.cypress.com/products/modustoolbox-software-environment) v3.1.0 or later (tested with v3.1.0)
- valid [Avnet IoTConnect Cloud Platform account](https://iotconnect.io/ebv) and click Request a Free IoTConnect Account
- **provisioned** OPTIGA™ Trust M with your IoTConnect account info


## Supported Hardware

The code has been developed and tested with:
- [The PSoC™ 62S2 Wi-Fi BT Pioneer Kit](https://www.infineon.com/cms/en/product/evaluation-boards/cy8ckit-062s2-43012/) (`CY8CKIT-062S2-43012`)
- EBV-IoT – Infineon PAS CO2 Evaluation Shield
- EBV-IoT – Infineon OPTIGA Trust M Evaluation Shield
- 128x128 pixels OLED display (optional)

Code can also be ported to:
- [Rapid IoT connect developer kit with PAS CO2 sensor.](https://www.infineon.com/cms/en/product/evaluation-boards/kit_csk_pasco2) (`CYSBSYSKIT-DEV-01`)

## Build Instructions
- Download, install and open [ModusToolbox™ software](https://www.cypress.com/products/modustoolbox-software-environment). 
On Windows, ensure that you **Run As Adminstrator** the installation package so that the neccessary drivers can be installed.
- Select a name for your workspace when prompted for a workspace name.
- **Import** the project into the workspace.
- Modify **/configs/wifi_config.h** with your WIFI_SSID and WIFI_PASSWORD.
- At this point you should be able to build and run the application by using the options in the **Quick Panel** on bottom left of the screen.   
- You should see the application output in your terminal emulator.
