/*
 * ebv_logs.c
 *
 *  Created on: 1. jun. 2023
 *      Author: MaliU
 */

#include <stdarg.h>

#include "ebv_logs.h"

#if TOOL_ENVIRONMENT == TOOL_ENVIRONMENT_INFINEON_MTB
	extern uint32_t tick;
#endif

ebv_logs_level_t ebv_logs_level = EBV_LOGS_ALL;

uint32_t ebv_logs_get_tick(void){

#if TOOL_ENVIRONMENT == TOOL_ENVIRONMENT_INFINEON_MTB
	return tick;
#elif TOOL_ENVIRONMENT == TOOL_ENVIRONMENT_INFINEON_MTB_FREERTOS
	return xTaskGetTickCount();
#endif

}

void ebv_logs_printf(const char *format, ...){
	int len = 0;
	va_list args;
	va_start(args, format);
	char tmp[512];

	len = vsnprintf(&tmp[len], sizeof(tmp), format, args);
	if (len == sizeof(tmp)) {
		ebv_logs_printf("Warning input string too long... now truncated!\r\n");
	}



#if TOOL_ENVIRONMET == TOOL_ENVIRONMET_INFINEON_MTB
	printf(tmp);
#endif

    va_end(args);
}


char* ebv_logs_timestamp(void)
{
    //return 0; //base + tick_count * (1000 / configTICK_RATE_HZ);
	//return Cy_SysTick_GetValue();
	uint32_t tmp_tick = ebv_logs_get_tick();
	static char buffer[18] = {0};
#if EBV_LOGS_IS_TIME_FORMATED
	unsigned int hours = tmp_tick/3600000;
	unsigned int minutes = (tmp_tick%3600000)/60000;
	unsigned int seconds = (tmp_tick%60000)/1000;
	sprintf(buffer, "%02d:%02d:%02d.%03d", hours, minutes, seconds, (unsigned int)(tmp_tick%1000));
#else
	sprintf(buffer, "%u", tmp_tick);
#endif

	return buffer;
}

void ebv_logs_write(ebv_logs_level_t level,
					ebv_logs_module_t module,
                   const char *format, ...)
{
	int len = 0;
	va_list args;
	va_start(args, format);
	char tmp[600];
    //ebv_log_writev(level, module, tag, format, list);
    if (level > ebv_logs_level) { //no log output if level to high
        return;
    }

	len = vsnprintf(&tmp[len], sizeof(tmp), format, args);
	if (len == sizeof(tmp)) {
		ebv_logs_write(level, module, "Warning input string too long... now truncated!\r\n");
	}

//    vsnprintf(tmp, sizeof(tmp), format, args);

    //ebv_logs_printf(tmp);
	printf(tmp);
    va_end(args);
}

//void ebv_logs_write(ebv_logs_level_t level,
//					ebv_logs_module_t module,
//                   const char *format, ...)
//{
//
//	va_list args;
//	va_start(args, format);
//    if (level > ebv_logs_level) { //no log output if level to high
//        return;
//    }
//
//    ebv_logs_printf(format, args);
//	//printf(tmp);
//    va_end(args);
//}

