/*
 * iotc_eeprom.c
 *
 *  Created on: 9. apr. 2023
 *      Author: MaliU
 */
#include "iotc_eeprom.h"


/* The size of data to store in EEPROM. Note flash size used will be
 * closest multiple of flash row size */
#define DATA_SIZE                       (CY_EM_EEPROM_FLASH_SIZEOF_ROW)
/* The Simple Mode is turned off */
#define SIMPLE_MODE                     (1u)
/* Increases the flash endurance twice */
#define WEAR_LEVELING                   (1u)
/* The Redundant Copy is turned off */
#define REDUNDANT_COPY                  (0u)
/* The Blocking Write is turned on */
#define BLOCKING_WRITE                  (1u)

CY_ALIGN(CY_EM_EEPROM_FLASH_SIZEOF_ROW)
const uint8_t emEepromStorage[CY_EM_EEPROM_GET_PHYSICAL_SIZE(DATA_SIZE, SIMPLE_MODE, WEAR_LEVELING, REDUNDANT_COPY)] = {0u};

cy_en_em_eeprom_status_t eeprom_result;
cy_stc_eeprom_context_t eepromContext;

cy_stc_eeprom_config_t eepromConfig =
{
    .eepromSize = DATA_SIZE,
    .simpleMode = SIMPLE_MODE,
    .wearLevelingFactor = WEAR_LEVELING,
    .redundantCopy = REDUNDANT_COPY,
    .blockingWrite = 1u, //1u,
    .userFlashStartAddr = (uint32_t)&(emEepromStorage[0u]),
};
