/*
 * iotc_eeprom.h
 *
 *  Created on: 9. apr. 2023
 *      Author: MaliU
 */

#ifndef SOURCE_IOTC_EEPROM_H_
#define SOURCE_IOTC_EEPROM_H_

#include "cy_em_eeprom.h"
#include "wifi_config.h"

extern cy_en_em_eeprom_status_t eeprom_result;
extern cy_stc_eeprom_context_t eepromContext;

extern cy_stc_eeprom_config_t eepromConfig;

#define EEPROM_DATA_VALID_ID 				47
#define LAT_LON_MAX_LENGTH 					32
#define LATITUDE                         	"48.17207000301404"
#define LONGITUDE							"11.801025558942381"

typedef struct {
	char sLatitude[LAT_LON_MAX_LENGTH];
	char sLongitude[LAT_LON_MAX_LENGTH];

} lat_lon_data_t;


typedef struct {
	wifi_credentials_t wifi_credentials_stored;
	lat_lon_data_t lat_lon_data_stored;
	unsigned char ucEEPROM_DataValid;
} eeprom_data_t;

extern eeprom_data_t eeprom_data;
extern lat_lon_data_t lat_lon_data;



#endif /* SOURCE_IOTC_EEPROM_H_ */
