package com.avnet.ebv.common


import android.content.Context
import android.content.SharedPreferences
import androidx.security.crypto.EncryptedSharedPreferences
import androidx.security.crypto.MasterKey


class SharedPref
{

    fun saveStringSession(key: String, value: String? = null)
    {
        sharedPreferences!!.edit().putString(key, value).apply()

    }

    fun saveStringSet(key: String, set: Set<String>? = null)
    {
        sharedPreferences!!.edit().putStringSet(key, set).apply()
    }

    fun getStringSet(key: String): Set<String>? = sharedPreferences!!.getStringSet(key, null)

    fun removeFromPreferences(key: String)
    {
        sharedPreferences!!.edit().remove(key).apply()
    }

    fun getValueFromPreferences(key: String): String? =
            sharedPreferences!!.getString(key, "")

    fun saveBooleanSession(key: String, value: Boolean = false)
    {
        sharedPreferences!!.edit().putBoolean(key, value).apply()
    }

    fun getBooleanValue(key: String): Boolean = sharedPreferences!!.getBoolean(key, false)

    fun saveIntegerSession(key: String, value: Int)
    {
        sharedPreferences!!.edit().putInt(key, value).apply()
    }

    fun getIntegerValue(key: String): Int = sharedPreferences!!.getInt(key, 0)

    fun saveLongSession(key: String, value: Long = 0L)
    {
        sharedPreferences!!.edit().putLong(key, value).apply()
    }

    fun getLongValue(key: String): Long = sharedPreferences!!.getLong(key, 0)

    fun deleteAllPreferences()
    {
        val editor = sharedPreferences!!.edit()
        editor.clear()
        editor.apply()
    }
    companion object
    {
        @get:Synchronized
        var instance: SharedPref? = null
            private set
        private var sharedPreferences: SharedPreferences? = null


        @Synchronized
        fun init(context: Context)
        {
            if (instance == null)
            {
                instance = SharedPref()
                val masterKey = MasterKey.Builder(context, MasterKey.DEFAULT_MASTER_KEY_ALIAS)
                    .setKeyScheme(MasterKey.KeyScheme.AES256_GCM)
                    .build()
                sharedPreferences = EncryptedSharedPreferences.create(
                    context,
                    context.applicationContext.getPackageName(),
                    masterKey,
                    EncryptedSharedPreferences.PrefKeyEncryptionScheme.AES256_SIV,
                    EncryptedSharedPreferences.PrefValueEncryptionScheme.AES256_GCM
                )
                /*sharedPreferences = context.getSharedPreferences(
                        context.applicationContext.getPackageName(), Context.MODE_PRIVATE)*/
            }
        }


    }
}