package com.avnet.ebv.data

import com.avnet.ebv.model.request.CreateRoleRequest
import com.avnet.ebv.model.request.LoginRequest
import com.avnet.ebv.model.request.NewEntityRequest
import com.avnet.ebv.model.response.*
import kotlinx.coroutines.flow.Flow


interface DataRepositorySource {

    suspend fun requestGetToken(): Flow<Resource<TokenResponse>>

    suspend fun requestRefereshToken(): Flow<Resource<RefreshTokenResponse>>

    suspend fun requestLogin(request: LoginRequest): Flow<Resource<LoginResponse>>

    suspend fun requestCountryList(): Flow<Resource<CountryListResponse>>

    suspend fun requestStateList(countryGuid:String): Flow<Resource<StateResponseList>>

    suspend fun requestEntityLookUp(): Flow<Resource<EntityLookUpResponse>>

    suspend fun requestRoleLookUp(): Flow<Resource<RoleLookUpResponse>>

    suspend fun requestAddNewEntity(request: NewEntityRequest): Flow<Resource<NewEntityResponse>>

    suspend fun requestDeviceList(params: Map<String, String?>): Flow<Resource<DeviceListResponse>>

    suspend fun requestCreateRole(request: CreateRoleRequest): Flow<Resource<CreateRoleResponse>>

    suspend fun requestGetRolePermissions(roleGuid:String): Flow<Resource<GetRolePermissionsResponse>>

}
