package com.avnet.ebv.data

import com.avnet.ebv.model.response.ErrorRespose

// A generic class that contains data and status about loading this data.
sealed class Resource<T>(
        val data: T? = null,
        val errorCode: Int? = null,
        val errorBody: ErrorRespose? = null
) {
    class Success<T>(data: T?) : Resource<T>(data)
    class Loading<T>(data: T? = null) : Resource<T>(data)
    class DataError<T>(errorCode: Int) : Resource<T>(null, errorCode)
    class DataErrorBody<T>(errorBody: ErrorRespose?) : Resource<T>(null,null, errorBody )

}