package com.avnet.ebv.data.interceptor


import com.avnet.ebv.EbvApplication
import com.avnet.ebv.MessageEvent
import com.avnet.ebv.R
import com.avnet.ebv.common.SharedPref
import com.avnet.ebv.data.remote.ApiConstant
import com.avnet.ebv.data.remote.ApiConstant.getBasicToken
import com.avnet.ebv.data.remote.ApiConstant.getLogin
import com.avnet.ebv.data.remote.ApiConstant.getRefereshToken
import com.avnet.ebv.log.AndroidLog
import com.avnet.ebv.utils.AppConstants
import okhttp3.Interceptor
import okhttp3.Response
import org.greenrobot.eventbus.EventBus

class HeaderInterceptor : Interceptor {
    /**
     * Interceptor class for setting of the headers for every request
     */
    override fun intercept(chain: Interceptor.Chain): Response {

        var token: String? = null

        var request = chain.request()

        //Below is the condition to pass Basic token in the APIs else pass access token once user logged in in the app.
        if (request.url.toString().contains(getLogin)) {

            token = "Basic " + SharedPref.instance!!.getValueFromPreferences(
                EbvApplication.context.getString(
                    R.string.pref_auth_token
                )
            )

            request = request.newBuilder()
                .addHeader("Accept", "application/json")
                .addHeader("Authorization", token.toString())
                .addHeader(
                    "solution-key",
                    "Q0EyN0UzRTItMzIxNC00ODI3LUEzNDktQzgwQjU1NkUwRTVFLWFjY2Vzc0tFWS0yMmRqNW5zYzZw"
                )
                .build()

        } else if (request.url.toString().contains(getBasicToken)) {

        }else if (request.url.toString().contains(getRefereshToken)) {

        }else if (request.url.toString().contains(ApiConstant.BASE_URL_SUBSCRIBE)) {
            token = "Bearer " + SharedPref.instance!!.getValueFromPreferences(
                EbvApplication.context.getString(
                    R.string.pref_auth_token_subscribe
                )
            )
            request = request.newBuilder()
                .addHeader("Accept", "text/plain")
                .addHeader("Content-Type", "application/json-patch+json")
                .addHeader("Authorization", token.toString())
                .build()
            AndroidLog.i("HeaderInterceptor => ", token.toString())
        }else{

            token = "Bearer " + SharedPref.instance!!.getValueFromPreferences(
                EbvApplication.context.getString(
                    R.string.pref_bearer_token
                )
            )
            AndroidLog.i("HeaderInterceptor => ", token.toString())
            request = request.newBuilder()
                .addHeader("Accept", "application/json")
                .addHeader("Authorization", token.toString())
                .build()
        }

        var response = chain.proceed(request)

        return response
//        return chain.proceed(request)
    }
}
