package com.avnet.ebv.data.interceptor


import com.avnet.ebv.EbvApplication
import com.avnet.ebv.MessageEvent
import com.avnet.ebv.R
import com.avnet.ebv.common.SharedPref
import com.avnet.ebv.data.remote.ApiConstant
import com.avnet.ebv.data.remote.ApiConstant.getBasicToken
import com.avnet.ebv.data.remote.ApiConstant.getLogin
import com.avnet.ebv.data.remote.ApiConstant.getRefereshToken
import com.avnet.ebv.log.AndroidLog
import com.avnet.ebv.utils.AppConstants
import okhttp3.Interceptor
import okhttp3.Response
import org.greenrobot.eventbus.EventBus

class HeaderInterceptorRoot : Interceptor {
    /**
     * Interceptor class for setting of the headers for every request
     */
    override fun intercept(chain: Interceptor.Chain): Response {

        var token: String? = null

        var request = chain.request()



        token = "Bearer " + SharedPref.instance!!.getValueFromPreferences(
            EbvApplication.context.getString(
                R.string.pref_bearer_token_root
            )
        )
        AndroidLog.i("HeaderInterceptor => ", token.toString())
        request = request.newBuilder()
            .addHeader("Accept", "application/json")
            .addHeader("Authorization", token.toString())
            .build()


        var response = chain.proceed(request)

        return response
    }
}
