package com.avnet.ebv.data.interceptor

import android.content.Intent
import com.avnet.ebv.EbvApplication
import com.avnet.ebv.R
import com.avnet.ebv.common.SharedPref
import com.avnet.ebv.data.ServiceGenerator
import com.avnet.ebv.data.remote.AuthApiService
import com.avnet.ebv.log.AndroidLog
import com.avnet.ebv.model.request.RefreshTokenRequest
import com.avnet.ebv.model.response.RefreshTokenResponse
import com.avnet.ebv.view.activity.AuthenticationActivity
import kotlinx.coroutines.runBlocking
import okhttp3.Authenticator
import okhttp3.Request
import okhttp3.Response
import okhttp3.Route
import retrofit2.Call
import java.io.IOException


class TokenAuthenticator: Authenticator {



    @Throws(IOException::class)
    override fun authenticate(route: Route?, response: Response): Request? {


        if (response.code == 401) {

            try {

                val refreshToken =
                    SharedPref.instance!!.getValueFromPreferences(EbvApplication.context.getString(R.string.pref_refresh_token))

                var client: AuthApiService = ServiceGenerator().retrofitAuth.create(AuthApiService::class.java)

                val token = SharedPref.instance!!.getValueFromPreferences(EbvApplication.context.getString(R.string.pref_bearer_token))!!.replace("Bearer ","")

                var refreshTokenRequest: RefreshTokenRequest = RefreshTokenRequest(token,refreshToken!!)
                val call: Call<RefreshTokenResponse> = client.refreshtoken(
                    refreshTokenRequest)
                    val tokenResponse: retrofit2.Response<RefreshTokenResponse> = call.execute()
                    if (tokenResponse.isSuccessful()) {
                        val refreshTokenResponse: RefreshTokenResponse? = tokenResponse.body()

                        SharedPref.instance!!.saveStringSession(
                            EbvApplication.context.getString(R.string.pref_bearer_token),
                            refreshTokenResponse?.accessToken
                        )
                        SharedPref.instance!!.saveStringSession(
                            EbvApplication.context.getString(R.string.pref_refresh_token),
                            refreshTokenResponse?.refreshToken
                        )

                        val token: String? ="Bearer " +
                            SharedPref.instance!!.getValueFromPreferences(EbvApplication.context.getString(R.string.pref_bearer_token))

                        AndroidLog.i("HeaderInterceptor => ", token.toString())

                        // Add new header to rejected request and retry it
                       return response.request.newBuilder().header("Authorization",token!!).build()

                    }
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }
        return null
    }
}