package com.avnet.ebv.data.remote

object ApiConstant {

    const val countryGuid = "countryGuid"
    const val roleGuid = "roleGuid"
    const val pageNumber = "pageNumber"
    const val pageSize = "pageSize"
    const val pageNo = "pageNo"

    const val BASE_URL_AUTH = "https://avnetauth.iotconnect.io/"
    const val BASE_URL_DEVICE = "https://avnetdevice.iotconnect.io/"
    const val BASE_URL_MASTER = "https://avnetmaster.iotconnect.io/"
    const val BASE_URL_USER = "https://avnetuser.iotconnect.io/"
    const val BASE_URL_USER2 = "avnetuser.iotconnect.io"
    const val BASE_URL_TELEMETRY = "https://avnettelemetry.iotconnect.io/"
//    const val BASE_URL_SUBSCRIBE = "https://subscriptionapi.iotconnect.io/"
    const val BASE_URL_SUBSCRIBE = "https://partnerservice.iotconnect.io/connectstudio-api-subscription/"
    const val getRefereshToken = "api/v2/Auth/refresh-token"

    //auth
    const val getBasicToken = "api/v2/Auth/basic-token"
    const val getLogin = "api/v2/Auth/login"
    const val getCountryList = "api/v1.1/Master/country"
    const val getStateList = "api/v1.1/Master/country/{countryGuid}/state"
    const val getEntityLookUp = "api/v2/Entity/lookup"
    const val getRoleLookUp = "api/v2/Role/lookup"
    const val getAddNewEntity = "api/v2/Entity"
    const val getTemplateAttribute = "api/v2/template-attribute/{deviceTemplateGuid}"
    const val getDeviceTemplate = "api/v2/device-template/{deviceTemplateGuid}"
    const val getHistoryData = "api/v2/Telemetry/attribute-history/device/{uniqueId}/from/{fromDate}/to/{toDate}"
    const val getTelemetryDevice = "api/v2/Telemetry/device/{deviceGuid}"
    const val getDeviceTemplate1 = "api/v2/device-template"

    //Device
    const val getDevice = "api/v2/Device"
    const val addDevice = "api/v2/Device"
    const val getUserIdentity = "api/v2/User/identity"
    const val twinPropertyLookup = "api/v2/template-setting/{deviceGuid}/lookup"
    const val twinPropertyHistory = "api/v2/Device/{deviceName}/twin"
    const val PropertyExecute = "api/v2/Device/{uniqueId}/twin"

    const val getSingleDeviceDetails = "api/v2/Device/uniqueId/{uniqueId}"
    const val addDeleteDeviceEntity = "api/v2/entity/{entityGuid}/device"

    const val CommandLookup = "api/v2/template-command/{deviceName}/lookup"
    const val CommandHistory = "api/v2/template-command/history"
    const val CommandExecute = "api/v2/template-command/device/{deviceName}/send"

    const val deviceGuid = "deviceGuid"
    const val userDevicePermissionGuid = "userDevicePermissionGuid"
    const val deviceName = "deviceName"
    const val uniqueId = "uniqueId"
    const val fromDate = "fromDate"
    const val toDate = "toDate"


    const val deviceTemplateGuid1 = "deviceTemplateGuid"
    const val entityGuid = "entityGuid"
    const val EBV_MOBILE = "EBV Mobile"


    //for add device template guid is static ...
    const val deviceTemplateGuid = "1CD121D5-1896-4AC7-B192-A767EDD96BC7"

    //subscribe
    const val getSubscribeToken = "api/v1/subscription/token"
    const val getConsumerId = "api/v1/company/{iotConnectCompanyId}"
    const val getSubscriber = "api/v1/subscriber/{solutionid}/{consumerid}/consumption/active"
    const val getPlan = "api/v1/solution/{solutionid}/plans"
    const val clientId = "clientId"
    const val clientSecret = "clientSecret"
    const val userName = "userName"
    const val clientIdValue = "f1e575ef-7a87-4ab8-983d-c0f8120b129d"
    const val clientSecretValue = "2BF9EBA7-5A62-41FB-8DDF-A330C2419AD6"
    const val iotConnectCompanyId  = "iotConnectCompanyId"
    const val environmentId  = "1EC35E14-D959-4FC2-4CAC-08D929D7F6A1"
    const val solutionid  = "solutionid"
    const val consumerid  = "consumerid"


    //delete
    const val deleteDevice = "api/v2/Device/{deviceGuid}"

    //role
    const val createRole = "api/v2/Role"
    const val getRolePermissions = "api/v2/Roleapi/v1.1/Authorize/role/{roleGuid}/permission"


    //allocation of device to one to one user.
    const val getDeviceGrantDetails = "api/v2/Device/{deviceGuid}/grant"

    const val addPermissionsDeviceDetails = "api/v2/Device/{deviceGuid}/grant"

    const val revokeAlocatedPermissions = "api/v2/Device/user-device-permission/{userDevicePermissionGuid}/revoke"


    const val updateDeviceEntity = "/api/v2/Device/{deviceGuid}"
}

