package com.avnet.ebv.data.remote

import com.avnet.ebv.model.request.CreateRoleRequest
import com.avnet.ebv.model.request.LoginRequest
import com.avnet.ebv.model.request.NewEntityRequest
import com.avnet.ebv.model.request.RefreshTokenRequest
import com.avnet.ebv.model.response.*
import retrofit2.Call
import retrofit2.Response
import retrofit2.http.Body
import retrofit2.http.GET
import retrofit2.http.POST
import retrofit2.http.Path

interface AuthApiService {

    @GET(ApiConstant.getBasicToken)
    suspend fun getTokenResponse(): Response<TokenResponse>

    @GET(ApiConstant.getRefereshToken)
    suspend fun getRefereshToken(): Response<RefreshTokenResponse>


    @POST(ApiConstant.getLogin)
    suspend fun getLoginApi(@Body request: LoginRequest): Response<LoginResponse>

    @GET(ApiConstant.getCountryList)
    suspend fun getCountryListResponse(): Response<CountryListResponse>

    @GET(ApiConstant.getStateList)
    suspend fun getStateListResponse(@Path(ApiConstant.countryGuid) countryGuid: String): Response<StateResponseList>

    @GET(ApiConstant.getEntityLookUp)
    suspend fun getEntityLookUp(): Response<EntityLookUpResponse>

    @GET(ApiConstant.getRoleLookUp)
    suspend fun getRoleLookUp(): Response<RoleLookUpResponse>

    @POST(ApiConstant.getAddNewEntity)
    suspend fun getAddNewEntity(@Body request: NewEntityRequest): Response<NewEntityResponse>

    @POST(ApiConstant.getRefereshToken)
    fun refreshtoken(@Body request: RefreshTokenRequest): Call<RefreshTokenResponse>

    @POST(ApiConstant.createRole)
    suspend fun createRoleApi(
        @Body request: CreateRoleRequest
    ): Response<CreateRoleResponse>

    @GET(ApiConstant.getRolePermissions)
    suspend fun getRolePermissionsApi(
        @Path(ApiConstant.roleGuid) roleGuid: String
    ): Response<GetRolePermissionsResponse>


}