package com.avnet.ebv.data.remote

import com.avnet.ebv.data.Resource
import com.avnet.ebv.model.request.*
import com.avnet.ebv.model.response.*
import com.avnet.ebv.model.response.subscribe.GetSubscribtionToken
import com.avnet.ebv.model.response.subscribe.PlanResponse
import com.avnet.ebv.model.response.subscribe.SubscriberResponse
import okhttp3.ResponseBody


internal interface RemoteDataSource {
    suspend fun requestGetToken(): Resource<TokenResponse>
    suspend fun requestRefreshToken(): Resource<RefreshTokenResponse>
    suspend fun reguestGetLogin(request: LoginRequest): Resource<LoginResponse>
    suspend fun requestDeviceList(params: Map<String, String?>): Resource<DeviceListResponse>
    suspend fun addDeviceList(request: AddDeviceRequest): Resource<AddDeviceResponse>
    suspend fun propertyLookupList(templateGuid: String): Resource<PropertyLookupResponse>
    suspend fun propertyHistoryList(deviceName: String): Resource<PropertyHistoryResponse>
    suspend fun commandLookupList(templateGuid: String): Resource<CommandLookupResponse>
    suspend fun commandHistoryList(params: Map<String, String?>): Resource<CommandHistoryResponse>
    suspend fun requestGetCountryList(): Resource<CountryListResponse>
    suspend fun requestGetStateList(countryGuid: String): Resource<StateResponseList>
    suspend fun requestGetUserIdentity(): Resource<UserIdentityResponse>
    suspend fun requestGetUserIdentityRoot(): Resource<UserIdentityResponse>
    suspend fun requestGetEntityLookUp(): Resource<EntityLookUpResponse>
    suspend fun requestGetRoleLookUp(): Resource<RoleLookUpResponse>
    suspend fun requestAddNewEntity(request: NewEntityRequest): Resource<NewEntityResponse>
    suspend fun requestExecuteCommand(commandGuId: String,request: ExecuteCommandRequest): Resource<ExecuteCommandResponse>
    suspend fun requestExecuteProperty(commandGuId: String,request: ExecutePropertyRequest): Resource<ExecuteCommandResponse>
    suspend fun getTemplateAttributeResponse(params: Map<String, String?>,deviceTemplateGuid:String): Resource<AttributeTemplateResponse>
    suspend fun getDeviceTemplateResponse(params: Map<String, String?>,deviceTemplateGuid:String): Resource<DeviceTemplateResponse>
    suspend fun getHistoryDataResponse(uniqueId:String,fromDate:String,toDate:String): Resource<HistoryDataResponse>
    suspend fun getTelemetryDeviceResponse(deviceTemplateGuid:String): Resource<TemplateResponse>
    suspend fun getDeviceTemplateResponse1(): Resource<MainDeviceTemplateResponse>
    suspend fun getSubscribeTokenResponse(params: Map<String, String?>): Resource<GetSubscribtionToken>
    suspend fun getConsumerId(iotConnectCompanyId: String): Resource<ResponseBody>
    suspend fun getSubscriber(solutionid: String,consumerid:String): Resource<SubscriberResponse>
    suspend fun getPlan(solutionid: String,params: Map<String, String?>): Resource<PlanResponse>
    suspend fun deleteDevice(deviceGuid: String): Resource<DeviceDeleteResponse>
    suspend fun getSingleDeviceDetails(uniqueId:String): Resource<SingleDeviceDetailResponse>
    suspend fun addDeviceEntity(entityGuid:String,request: AddDeleteDeviceEntityRequest): Resource<DeviceUpdateResponse>
    suspend fun deleteDeviceEntity(entityGuid:String,request: AddDeleteDeviceEntityRequest): Resource<DeviceUpdateResponse>
    suspend fun createRoleApi(request: CreateRoleRequest): Resource<CreateRoleResponse>
    suspend fun getRolePermissionsApi(roleGuid:String): Resource<GetRolePermissionsResponse>

    suspend fun getDeviceGrantDetailsApi(deviceGuid:String): Resource<GetDeviceAllocatedDetailsResponse>
    suspend fun addPermissionsDeviceDetails(deviceGuid:String, request: GrantDevicePermissionRequest): Resource<DeviceGrantedPermissionsResponse>
    suspend fun revokeAlocatedPermissionsApi(userDevicePermissionGuid:String): Resource<RevokeDevicePermissionsResponse>

    suspend fun updateDeviceEntity(deviceGuid :String,request: UpdateDeviceEntityRequest): Resource<DeviceUpdateResponse>

}
