/*
 * Copyright (C) 2017 The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.avnet.ebv.di
import com.avnet.ebv.view.activity.*
import com.avnet.ebv.view.fragment.*
import com.avnet.ebv.view.fragment.AddDeviceFragment
import com.avnet.ebv.view.fragment.DeviceListFragment
import com.avnet.ebv.view.fragment.auth.login.LoginFragment
import com.avnet.ebv.view.fragment.auth.signup.SignUpFragment
import com.avnet.ebv.view.fragment.DataFragment
import com.avnet.ebv.view.fragment.auth.login.LoginRootUserFragment
import dagger.Module
import dagger.android.ContributesAndroidInjector

@Suppress("unused")
@Module
abstract class ActivityModuleBuilder {
    @ContributesAndroidInjector()
    abstract fun contributeSplashActivity(): SplashActivity

    @ContributesAndroidInjector()
    abstract fun contributeAuthenticationActivity(): AuthenticationActivity

    @ContributesAndroidInjector()
    abstract fun contributeMainActivity(): MainActivity

    @ContributesAndroidInjector()
    abstract fun contributeDeviceDetailActivity(): DeviceDetailActivity

    @ContributesAndroidInjector()
    abstract fun contributeHistoryDataActivity(): HistoryDataActivity

    @ContributesAndroidInjector()
    abstract fun contributeLiveDataActivity(): LiveDataActivity


    @ContributesAndroidInjector()
    abstract fun contributeLoginFragment(): LoginFragment

    @ContributesAndroidInjector()
    abstract fun contributeLoginRootUserFragment(): LoginRootUserFragment

    @ContributesAndroidInjector()
    abstract fun contributeDeviceListFragment(): DeviceListFragment

    @ContributesAndroidInjector()
    abstract fun contributeAddDeviceFragment(): AddDeviceFragment

    @ContributesAndroidInjector()
    abstract fun contributeSignUpFragment(): SignUpFragment

    @ContributesAndroidInjector()
    abstract fun contributeUserSettingFragment(): UserSettingFragment

    @ContributesAndroidInjector()
    abstract fun contributeStatisticFragment(): StatisticFragment

    @ContributesAndroidInjector()
    abstract fun contributePropertiesFragment(): PropertiesFragment

    @ContributesAndroidInjector()
    abstract fun contributeCommandFragment(): CommandFragment

    @ContributesAndroidInjector()
    abstract fun contributeDataFragment(): DataFragment

    @ContributesAndroidInjector()
    abstract fun contributeHistoryFragment(): HistoryFragment

    @ContributesAndroidInjector()
    abstract fun contributeData2Fragment(): Data2Fragment


}