package com.avnet.ebv.log

import android.util.Log

object AndroidLog {
    private const val MSG_PREFIX = "[AndroidLog] "
    private const val TAG_PREFIX = ""

    // private static File file = new
    // File(Environment.getExternalStorageDirectory(), "crash.txt");
    fun printStackTrace(Tag: String, e: Exception?) {
        if (e != null) {
            var sb = StringBuilder()
            val stackTraceElements = e.stackTrace
            e(
                Tag, StringBuilder().append("------ ").append(e.toString()).append(" -----")
                    .toString()
            )
            if (e.cause != null) {
                val cause = e.cause
                val causeErrorMessage = cause!!.message
                e(
                    Tag,
                    StringBuilder().append("------ ").append(causeErrorMessage).append(" -----")
                        .toString()
                )
            }
            if (e.message != null) {
                e(
                    Tag, StringBuilder().append("------ ").append(e.message).append(" -----")
                        .toString()
                )
            }
            for (traceElement in stackTraceElements) {
                sb.append(traceElement.className).append(" - ").append(traceElement.methodName)
                    .append(" - ").append(traceElement.lineNumber)
                e(Tag, sb.toString())
                sb = StringBuilder()
            }
        } else {
        }
    }

    // private synchronized static void createFileLog(String tag,String
    // message){
    // try
    // {
    // if (!file.exists())
    // {
    // file.createNewFile();
    // }
    // } catch (Exception e) {
    // e.printStackTrace();
    // }
    // BufferedWriter outputStream;
    // try
    // {
    // String str = "\n  " + tag + "====== >>>>>";
    // outputStream = new BufferedWriter(new FileWriter(file,true));
    // outputStream.append(str);
    // outputStream.append(message);
    // outputStream.flush();
    // outputStream.close();
    // } catch (FileNotFoundException e) {
    // e.printStackTrace();
    // } catch (IOException e) {
    // e.printStackTrace();
    // }
    // }
    fun v(tag: String, message: String) {
        Log.v(TAG_PREFIX + tag, MSG_PREFIX + message)
    }

    fun d(tag: String, message: String) {
        Log.d(TAG_PREFIX + tag, MSG_PREFIX + message)
    }

    fun i(tag: String, message: String) {
        Log.i(TAG_PREFIX + tag, MSG_PREFIX + message)
    }

    fun w(tag: String, message: String) {
        Log.w(TAG_PREFIX + tag, MSG_PREFIX + message)
    }

    fun e(tag: String, message: String) {
        Log.e(TAG_PREFIX + tag, MSG_PREFIX + message)
    }

    // Message plus throwables
    fun v(tag: String, message: String, tr: Throwable?) {
        Log.v(TAG_PREFIX + tag, MSG_PREFIX + message, tr)
    }

    fun d(tag: String, message: String, tr: Throwable?) {
        Log.d(TAG_PREFIX + tag, MSG_PREFIX + message, tr)
    }

    fun i(tag: String, message: String, tr: Throwable?) {
        Log.i(TAG_PREFIX + tag, MSG_PREFIX + message, tr)
    }

    fun w(tag: String, message: String, tr: Throwable?) {
        Log.w(TAG_PREFIX + tag, MSG_PREFIX + message, tr)
    }

    fun e(tag: String, message: String, tr: Throwable?) {
        Log.e(TAG_PREFIX + tag, MSG_PREFIX + message, tr)
    }
}