package com.avnet.ebv.view.activity

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import androidx.navigation.NavController
import androidx.navigation.NavGraph
import androidx.navigation.findNavController
import com.avnet.ebv.R
import com.avnet.ebv.base.BaseActivity
import com.avnet.ebv.common.SharedPref
import com.avnet.ebv.databinding.ActivityAuthenticationBinding
import com.avnet.ebv.utils.AppConstants
import com.avnet.ebv.view.fragment.auth.login.LoginFragment

class AuthenticationActivity : BaseActivity() {

    private lateinit var binding: ActivityAuthenticationBinding
    lateinit var view: View
    lateinit var navController: NavController
    var fragmentHost: Int = 0
    lateinit var graph: NavGraph


    override fun initViewBinding() {
        binding = ActivityAuthenticationBinding.inflate(layoutInflater)
        view = binding.root
        setContentView(view)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        SharedPref.instance!!.saveStringSession(
            getString(R.string.pref_is_main_first_time),
            "0"
        )

        navController = findNavController(R.id.nav_auth_host_fragment)
        val inflater = navController.navInflater
        graph = inflater.inflate(R.navigation.navigation_auth)

        if ((SharedPref.instance?.getValueFromPreferences(resources.getString(R.string.pref_is_root_user_logged_in)) == null) || (SharedPref.instance?.getValueFromPreferences(
                resources.getString(R.string.pref_is_root_user_logged_in)
            )!!.isEmpty())
        ) {
            graph.setStartDestination(R.id.nav_root_user_login)
        }else{
            graph.setStartDestination(R.id.nav_login)
        }

        navController.setGraph(graph, intent.extras)


    }

    companion object {
        fun newIntent(context: Context): Intent {
            return Intent(context, AuthenticationActivity::class.java)
        }
    }

}