package com.avnet.ebv.view.activity

import android.content.Context
import android.content.Intent
import android.content.pm.ActivityInfo
import android.os.Bundle
import android.view.View
import androidx.viewpager.widget.ViewPager
import com.avnet.ebv.R
import com.avnet.ebv.base.BaseActivity
import com.avnet.ebv.databinding.ActivityDeviceDetailBinding
import com.avnet.ebv.databinding.ActivityHistoryDataBinding
import com.avnet.ebv.model.response.DeviceListResponse
import com.avnet.ebv.utils.AppConstants
import com.avnet.ebv.view.adater.ViewPagerAdapter
import com.avnet.ebv.view.fragment.CommandFragment
import com.avnet.ebv.view.fragment.DataFragment
import com.avnet.ebv.view.fragment.HistoryFragment
import com.avnet.ebv.view.fragment.PropertiesFragment

class HistoryDataActivity() : BaseActivity() {

    var uniqueId:String=""
    var deviceGuidId:String=""


    lateinit var binding: ActivityHistoryDataBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        uniqueId= intent.getStringExtra(AppConstants.uniqueId).toString()
        deviceGuidId= intent.getStringExtra(AppConstants.deviceGuidId).toString()
        replaceFragment(HistoryFragment(
            uniqueId,
            deviceGuidId
        ),false,true)

    }

    override fun initViewBinding() {
        binding = ActivityHistoryDataBinding.inflate(layoutInflater)
        setContentView(binding.root)
        binding.toolbar.ivMenu.setImageResource(R.drawable.ic_back)
        binding.toolbar.ivAdd.visibility = View.INVISIBLE
        binding.toolbar.tvTitle.setText("History Data")

        binding.toolbar.ivMenu.setOnClickListener(View.OnClickListener {
            finish()
        })
    }

    companion object {
        fun newIntent(context: Context): Intent {
            return Intent(context, HistoryDataActivity::class.java)
        }
    }

}