package com.avnet.ebv.view.adater

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.avnet.ebv.R
import com.avnet.ebv.base.BaseActivity
import com.avnet.ebv.base.BaseFragment
import com.avnet.ebv.databinding.*
import com.avnet.ebv.model.response.CommandHistoryDataItem
import com.avnet.ebv.model.response.DeviceListResponse
import java.lang.Exception


/*
class CommandAdapter(
    var deviceList: ArrayList<CommandHistoryDataItem?>,
    recyclerView: RecyclerView,
    var totalCount: Int
) :
    RecyclerView.Adapter<RecyclerView.ViewHolder>() {
    private var onViewClickListener: OnViewClickListener? = null
    
    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): RecyclerView.ViewHolder =
        when (viewType) {
            AdapterViewType.FILL_VIEW.type -> {
                val view =
                    LayoutInflater.from(parent.context)
                        .inflate(R.layout.row_command, parent, false)

                val binding = RowCommandBinding.bind(view)
                AlertViewHolder(binding)
            }

            AdapterViewType.PROGRESS.type -> {
                val view = LayoutInflater.from(parent.context)
                    .inflate(R.layout.view_progress_loading, parent, false)
                val binding = ViewProgressLoadingBinding.bind(view)
                ProgressViewHolder(binding)
            }
            else -> {

                val view = LayoutInflater.from(parent.context)
                    .inflate(R.layout.view_no_data_found, parent, false)
                val binding = ViewNoDataFoundBinding.bind(view)
                EmptyViewHolder(binding)

            }
        }

    override fun onBindViewHolder(holder: RecyclerView.ViewHolder, position: Int) {
        if (holder is AlertViewHolder) {
            holder.itemView.tag = position
            holder.txtName.text = deviceList[position]!!.cmdText
            holder.txtDesiredValue.text = deviceList[position]!!.statusDate
            holder.txtDesiredUpdateDate.text = deviceList[position]!!.createdByName
            holder.txtReportedValue.text = deviceList[position]!!.status.toString()
            holder.txtReportedUpdatedDate.text = deviceList[position]!!.resendHistory!!.resendCount.toString()


        } else if (holder is EmptyViewHolder) {
            holder.tvNoDataFound.text =
                holder.itemView.context.getString(R.string.no_data_found)
        }
    }

    override fun getItemViewType(position: Int): Int {
        return if (deviceList.size == 0 && !isLoading)
            AdapterViewType.EMPTY_VIEW.type
        else if (deviceList.size > 0 && isLoading && deviceList[position] == null) {
            AdapterViewType.PROGRESS.type
        } else if (deviceList.size == 0 && isLoading) {
            AdapterViewType.PROGRESS.type
        } else
            AdapterViewType.FILL_VIEW.type
    }

    override fun getItemCount(): Int {
        return if (deviceList.size == 0) 1 else deviceList.size
    }


    fun setOnViewClickListener(onViewClickListener: OnViewClickListener) {
        this.onViewClickListener = onViewClickListener
    }

    private class AlertViewHolder(view: RowCommandBinding) :
        RecyclerView.ViewHolder(view.root) {
        val txtName = view.txtName
        val txtDesiredValue = view.txtDesiredValue
        val txtDesiredUpdateDate = view.txtDesiredUpdateDate
        val txtReportedValue = view.txtReportedValue
        val txtReportedUpdatedDate = view.txtReportedUpdatedDate
    }

    private class ProgressViewHolder(view: ViewProgressLoadingBinding) :
        RecyclerView.ViewHolder(view.root)

    private class EmptyViewHolder(view: ViewNoDataFoundBinding) :
        RecyclerView.ViewHolder(view.root) {
        val tvNoDataFound: TextView = view.tvNoDataFound
    }

    interface OnViewClickListener {
        fun onItemClick(position: Int)
    }
}
*/




class CommandAdapter(
    var deviceList: ArrayList<CommandHistoryDataItem?>) :
    RecyclerView.Adapter<CommandAdapter.ViewHolder>() {

    private var onViewClickListener: OnViewClickListener? = null

    lateinit var context: Context
    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): CommandAdapter.ViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.row_command, parent, false)
        context = parent.context
        val binding = RowCommandBinding.bind(view)
        return ViewHolder(binding)
    }


    override fun getItemCount(): Int {
        return deviceList.size
    }


    fun setOnViewClickListener(onViewClickListener: OnViewClickListener) {
        this.onViewClickListener = onViewClickListener
    }

    interface OnViewClickListener {
        fun onItemClick(position: Int)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {

        try{
            holder.itemView.tag = position
            holder.bindItems(deviceList[position]!!)

            holder.binding.txtName.text = deviceList[position]!!.cmdText
            if(deviceList[position]!!.statusDate!=null && (!deviceList[position]!!.statusDate?.isEmpty()!!) ){
                val currentString =
                    deviceList[position]!!.statusDate
                val separated = currentString?.split(".")?.toTypedArray()
                var label = (context as BaseActivity).getFullDate(separated?.get(0).toString())

                holder.binding.txtDesiredValue.text = label
            }else{
                holder.binding.txtDesiredValue.text = "NA"
            }


            holder.binding.txtDesiredUpdateDate.text = deviceList[position]!!.createdByName
            holder.binding.txtReportedValue.text = deviceList[position]!!.status.toString()
            holder.binding.txtReportedUpdatedDate.text = deviceList[position]!!.resendHistory!!.resendCount.toString()


        }catch (e:Exception){

        }


    }

    class ViewHolder(var binding: RowCommandBinding) : RecyclerView.ViewHolder(binding.root) {
        fun bindItems(s: CommandHistoryDataItem) {

        }
    }

}