package com.avnet.ebv.view.adater

import android.content.Context
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.databinding.DataBindingUtil
import androidx.recyclerview.widget.RecyclerView
import com.avnet.ebv.R
import com.avnet.ebv.databinding.RowDeviceBinding
import com.avnet.ebv.model.response.DeviceListResponse
import java.util.*
import com.chauthai.swipereveallayout.ViewBinderHelper
import kotlinx.android.synthetic.main.row_device.view.*


class DeviceListAdapter(var deviceList: ArrayList<DeviceListResponse.Data?>) :
    RecyclerView.Adapter<DeviceListAdapter.ViewHolder>() {

    private var onViewClickListener: OnViewClickListener? = null

    lateinit var context: Context

    val viewBinderHelper = ViewBinderHelper()

    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): DeviceListAdapter.ViewHolder {

        context=parent.context
        viewBinderHelper.setOpenOnlyOne(true)
        var binding:RowDeviceBinding=DataBindingUtil.inflate(LayoutInflater.from(parent.context),R.layout.row_device, parent, false)
        return ViewHolder(binding)
    }


    override fun getItemCount(): Int {
        return deviceList.size
    }


    fun setOnViewClickListener(onViewClickListener: OnViewClickListener) {
        this.onViewClickListener = onViewClickListener
    }

    interface OnViewClickListener {
        fun onItemClick(position: Int,view:View)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {

        viewBinderHelper.bind(holder.binding.swipe, position.toString())
        viewBinderHelper.closeLayout(position.toString())


        holder.itemView.tag = position
        holder.bindItems(deviceList[position]!!)

        if (deviceList[position]!!.isConnected == true) {

            holder.binding.ivIndicator.setBackgroundColor(
                ContextCompat.getColor(
                    context,
                    R.color.colorGreenIndicator
                )
            )
        } else {
            holder.binding.ivIndicator.setBackgroundColor(
                ContextCompat.getColor(
                    context,
                    R.color.colorRedIndicator
                )
            )
        }

        holder.itemView.llMain.setOnClickListener {
            holder.itemView.isSelected = true
            onViewClickListener?.onItemClick(position,holder.itemView.llMain)
        }

        holder.itemView.rlDelete.setOnClickListener {
            holder.itemView.isSelected = true
            onViewClickListener?.onItemClick(position,holder.itemView.rlDelete)
        }
    }

    class ViewHolder(var binding: RowDeviceBinding) : RecyclerView.ViewHolder(binding.root) {
        fun bindItems(s: DeviceListResponse.Data) {
            binding.tvDeviceName.text = s.displayName
        }
    }
}