package com.avnet.ebv.view.adater

import android.content.Context
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.avnet.ebv.R
import com.avnet.ebv.databinding.RowLegendBinding
import com.avnet.ebv.model.response.LegendData
import kotlinx.android.synthetic.main.row_legend.view.*
import java.util.*


class LegendAdapter(var legendList: ArrayList<LegendData>) :
    RecyclerView.Adapter<LegendAdapter.ViewHolder>() {

    private var onViewClickListener: OnViewClickListener? = null

    lateinit var context: Context

    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): LegendAdapter.ViewHolder {
        val view = LayoutInflater.from(parent.context).inflate(R.layout.row_legend, parent, false)
        context = parent.context
        val binding = RowLegendBinding.bind(view)
        return ViewHolder(binding)
    }


    override fun getItemCount(): Int {
        return legendList.size
    }


    fun setOnViewClickListener(onViewClickListener: OnViewClickListener) {
        this.onViewClickListener = onViewClickListener
    }

    interface OnViewClickListener {
        fun onItemClick(position: Int)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.itemView.tag = position
        holder.bindItems(legendList[position]!!)

        if (legendList[position].isCheck == true) {

           holder.itemView.ivCheck.setImageResource(R.drawable.ic_checked)
        } else {
            holder.itemView.ivCheck.setImageResource(R.drawable.ic_uncheck)
        }

        holder.itemView.setOnClickListener {
            onViewClickListener?.onItemClick(position)
        }
    }

    class ViewHolder(var binding: RowLegendBinding) : RecyclerView.ViewHolder(binding.root) {
        fun bindItems(s: LegendData) {
//            binding.tvCheck.text =  org.apache.commons.lang3.StringUtils.capitalize(
//                s.name
//            )

            binding.tvCheck.text =  s.name

            binding.ivIndicator.setBackgroundColor(s.isIndicator)
        }
    }

}