package com.avnet.ebv.view.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.databinding.ViewDataBinding
import androidx.fragment.app.Fragment
import androidx.navigation.fragment.findNavController


abstract class BaseFragment()  : Fragment()
{
    lateinit var binding: ViewDataBinding

    override fun onResume()
    {
        super.onResume()

     }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?): View? {
        binding = DataBindingUtil.inflate(inflater, contentView(), container,false)
        return binding.root
    }
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        initViews()
        loadData()
    }
    fun getBindingLayout() : ViewDataBinding {
        return binding
    }
    fun refreshCurrentFragment(){
        val id = findNavController().currentDestination?.id
        findNavController().popBackStack(id!!,true)
        findNavController().navigate(id)
    }

    //Abstract Methods
    protected abstract fun contentView(): Int
    protected abstract fun initViews()
    protected abstract fun setTitle(): String
    protected abstract fun loadData()

}
