package com.avnet.ebv.view.fragment

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import android.content.IntentFilter
import android.content.res.Configuration
import android.graphics.Color
import android.os.Build
import android.os.Bundle
import android.util.DisplayMetrics
import android.util.Log
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.LinearLayout
import androidx.annotation.RequiresApi
import androidx.core.content.ContextCompat
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import com.avnet.ebv.R
import com.avnet.ebv.ViewModelFactory
import com.avnet.ebv.base.BaseFragment
import com.avnet.ebv.databinding.FragmentHistoryBinding
import com.avnet.ebv.enums.ProgressState
import com.avnet.ebv.model.response.LegendData
import com.avnet.ebv.utils.AppConstants
import com.avnet.ebv.view.activity.DeviceDetailActivity
import com.avnet.ebv.view.adater.LegendAdapter
import com.avnet.ebv.viewmodel.HistoryDataViewModel
import com.github.mikephil.charting.charts.LineChart
import com.github.mikephil.charting.components.Legend
import com.github.mikephil.charting.components.XAxis
import com.github.mikephil.charting.data.Entry
import com.github.mikephil.charting.data.LineData
import com.github.mikephil.charting.data.LineDataSet
import com.github.mikephil.charting.formatter.IndexAxisValueFormatter
import com.github.mikephil.charting.interfaces.datasets.ILineDataSet
import kotlinx.android.synthetic.main.fragment_history.*
import java.text.SimpleDateFormat
import java.util.*
import javax.inject.Inject
import kotlin.collections.ArrayList


class HistoryFragment(var uniqueId: String, var deviceGuidId: String) : BaseFragment(),
    View.OnClickListener {

    private val TAG: String = "HistoryFragment"


    private lateinit var mBinding: FragmentHistoryBinding

    @Inject
    lateinit var viewModelFactory: ViewModelFactory

    @Inject
    lateinit var historyDataViewModel: HistoryDataViewModel

    var livedataSetsList: ArrayList<LineDataSet> = ArrayList()
    var livedataSets2List: ArrayList<LineDataSet> = ArrayList()
    var livedataSets3List: ArrayList<LineDataSet> = ArrayList()

    val xAxisLabel: ArrayList<String> = ArrayList()

    public lateinit var lineChart: LineChart

    var legendList: ArrayList<LegendData> = ArrayList()

    lateinit var legendAdapter: LegendAdapter

    lateinit var deviceDetailActivity: DeviceDetailActivity

    private val mMessageReceiver: BroadcastReceiver = object : BroadcastReceiver() {
        override fun onReceive(context: Context?, intent: Intent) {

//            historyDataViewModel._attributeList1.clear()
//            historyDataViewModel._attributeList.value?.clear()
//            legendList.clear()
//            setDate()
//            historyDataViewModel.getTemplateAttributeList(deviceGuidId)
        }
    }

    companion object {
    }

    override fun onAttach(context: Context) {
        super.onAttach(context)

        Log.d(TAG, "onAttach")

        deviceDetailActivity = (context as DeviceDetailActivity)


    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        mBinding = FragmentHistoryBinding.inflate(layoutInflater)
        return mBinding.root
    }


    override fun initViewModel() {
        historyDataViewModel = viewModelFactory.create(HistoryDataViewModel::class.java)
        mBinding.setLifecycleOwner(this)
        mBinding.historyDataViewModel = historyDataViewModel
        historyDataViewModel.initializeWithContext(context!!)
        setDate()
        historyDataViewModel.uniqueId.value = uniqueId
        historyDataViewModel.deviceTemplateGuid = deviceGuidId
        historyDataViewModel.getTemplateAttributeList(deviceGuidId)
    }

    private fun setDate() {
        val calender = Calendar.getInstance()
//        calender.add(Calendar.DATE,-1)
//        calender.add(Calendar.HOUR, -4);
        val c: Date = calender.getTime()
        println("Current time => $c")

        val df = SimpleDateFormat("YYYY-MM-dd HH:mm:ss", Locale.getDefault())
        val currentDate: String = df.format(c)
        Log.d("current date", currentDate)
        historyDataViewModel.toDate.value = currentDate

        val c1 = Calendar.getInstance()
        c1.add(Calendar.HOUR, -24);
//        c1.add(Calendar.DATE, -1);
//        c1.add(Calendar.DATE, -2);
        val pastDate: Date = c1.getTime()
        val pastDate1: String = df.format(pastDate)
        Log.d("past date", pastDate1)
        historyDataViewModel.fromDate.value = pastDate1
    }

    override fun observeViewModel() {

//        historyDataViewModel._ProgreeBarState.observe(this, Observer {
//            when (it) {
//                ProgressState.HIDE -> dismissProgressDialog()
//                ProgressState.SHOW -> showProgressDialog()
//            }
//        })

        historyDataViewModel._attributeFeedList.observe(this, Observer {


            try {
                if (historyDataViewModel._attributeList.value?.size!! > 0) {


                    val rainbow = context!!.resources.getIntArray(R.array.rainbow)
                    val rainbow2 = context!!.resources.getIntArray(R.array.rainbow2)
                    var k: Int = 0
                    var l: Int = 0
                    livedataSetsList = ArrayList()
                    livedataSets2List = ArrayList()
                    legendList.clear()
                    for (i in 0 until historyDataViewModel._attributeList.value?.size!!) {


                        /* if (
                             ((historyDataViewModel._attributeList1.get(i).description.equals(
                                 "",
                                 true
                             )) && checkDataType(historyDataViewModel._attributeList1.get(i).dataTypeName.toString()))
                             ||
                             ((historyDataViewModel._attributeList1.get(i).description!!.contains(
                                 AppConstants.sensorTypeGraph,
                                 true
                             )) && checkDataType(historyDataViewModel._attributeList1.get(i).dataTypeName.toString()))
                         ) {*/


                        if (checkDataType(historyDataViewModel._attributeList1.get(i).dataTypeName.toString())) {
                            if (historyDataViewModel._attributeList1.get(i).attributes != null && historyDataViewModel._attributeList1.get(
                                    i
                                ).attributes.size > 0
                            ) {

                                //if attribute list is present then we need to make linedataset for each attribute in attribute list...
                                for (k in 0 until historyDataViewModel._attributeList1.get(i).attributes.size) {

                                    var values: ArrayList<Entry> = ArrayList()
                                    values = ArrayList()

                                    var set1: LineDataSet =
                                        LineDataSet(
                                            values,
                                            historyDataViewModel._attributeList1.get(i).localName + "." + historyDataViewModel._attributeList1.get(
                                                i
                                            ).attributes.get(k).localName
                                        )
                                    set1.setDrawIcons(false)
                                    if (!historyDataViewModel._attributeList1.get(i).attributes.get(
                                            k
                                        ).attributeColor!!.isEmpty()
                                    ) {
                                        set1.setCircleColor(
                                            Color.parseColor(
                                                historyDataViewModel._attributeList1.get(
                                                    i
                                                ).attributes.get(k).attributeColor
                                            )
                                        )
                                    } else {
                                        set1.setCircleColor(rainbow2[l])
                                    }

//                                    set1.setCircleColor(rainbow2[l])
                                    set1.setDrawCircleHole(true)
                                    set1.setDrawValues(false)
                                    set1.lineWidth = 2F
                                    set1.setCubicIntensity(0.2f)
                                    set1.setDrawHorizontalHighlightIndicator(false)
                                    set1.setMode(LineDataSet.Mode.CUBIC_BEZIER)
                                    if (!historyDataViewModel._attributeList1.get(i).attributes.get(
                                            k
                                        ).attributeColor!!.isEmpty()
                                    ) {
                                        set1.color = Color.parseColor(
                                            historyDataViewModel._attributeList1.get(i).attributes.get(
                                                k
                                            ).attributeColor
                                        )
                                    } else {
                                        set1.color = rainbow2[l]
                                    }

                                    livedataSetsList.add(set1)
                                    if (!historyDataViewModel._attributeList1.get(i).attributes.get(
                                            k
                                        ).attributeColor!!.isEmpty()
                                    ) {
                                        legendList.add(
                                            LegendData(
                                                Color.parseColor(
                                                    historyDataViewModel._attributeList1.get(
                                                        i
                                                    ).attributes.get(k).attributeColor
                                                ),
                                                historyDataViewModel._attributeList1.get(i).localName + "." + historyDataViewModel._attributeList1.get(
                                                    i
                                                ).attributes.get(k).localName,
                                                true
                                            )
                                        )
                                    } else {
                                        legendList.add(
                                            LegendData(
                                                rainbow2.get(l),
                                                historyDataViewModel._attributeList1.get(i).localName + "." + historyDataViewModel._attributeList1.get(
                                                    i
                                                ).attributes.get(k).localName,
                                                true
                                            )
                                        )
                                    }

                                    l++
                                    if (l == rainbow2.size) {
                                        l = 0
                                    }
                                }

                            } else {
                                //if no attribute list present then for graph live data sensor we will have only one line data set...
                                var values: ArrayList<Entry> = ArrayList()
                                values = ArrayList()
                                var set1: LineDataSet =
                                    LineDataSet(
                                        values,
                                        historyDataViewModel._attributeList.value!!.get(i).localName
                                    )
                                set1.setDrawIcons(false)
                                if (!historyDataViewModel._attributeList.value!!.get(i).attributeColor!!.isEmpty()) {
                                    set1.setCircleColor(
                                        Color.parseColor(
                                            historyDataViewModel._attributeList.value!!.get(
                                                i
                                            ).attributeColor!!
                                        )
                                    )
                                } else {
                                    set1.setCircleColor(rainbow[k])
                                }

                                set1.setDrawCircleHole(true)
                                set1.setDrawValues(false)
                                set1.lineWidth = 2F
                                set1.setCubicIntensity(0.2f)
                                set1.setDrawHorizontalHighlightIndicator(false)
                                set1.setMode(LineDataSet.Mode.CUBIC_BEZIER)
                                if (!historyDataViewModel._attributeList.value!!.get(i).attributeColor!!.isEmpty()) {
                                    set1.color = Color.parseColor(
                                        historyDataViewModel._attributeList.value!!.get(i).attributeColor!!
                                    )
                                } else {
                                    set1.color = rainbow[k]
                                }


                                livedataSetsList.add(set1)
                                if (!historyDataViewModel._attributeList.value!!.get(i).attributeColor!!.isEmpty()) {
                                    legendList.add(
                                        LegendData(
                                            Color.parseColor(
                                                historyDataViewModel._attributeList.value!!.get(
                                                    i
                                                ).attributeColor!!
                                            ),
                                            historyDataViewModel._attributeList.value!!.get(i).localName.toString(),
                                            true
                                        )
                                    )
                                } else {
                                    legendList.add(
                                        LegendData(
                                            rainbow.get(k),
                                            historyDataViewModel._attributeList.value!!.get(i).localName.toString(),
                                            true
                                        )
                                    )
                                }


                            }
                            k = k + 1
                            if (k == rainbow.size) {
                                k = 0
                            }
                        }

                    }


                }

                if (it.size > 0) {
                    Log.d("feed size ", it.size!!.toString())
                    mBinding.cvLegend.visibility = View.VISIBLE
                    mBinding.tvHistory?.visibility = View.VISIBLE
                    mBinding.btnLandscape?.visibility = View.VISIBLE
                    //loop for each line data sets looping with all the response sizeee...
                    for (j in 0 until livedataSetsList.size) {
                        for (i in 0 until it.size) {

//                            Log.d("feed value "+i, it!!.get(i).toString())

                            //Parse any value
                            var attrInsideList: Map<String, String> =
                                HashMap()  //when the response object begins with array list
                            var attrSub: Map<String, String> =
                                HashMap()//when the response object begins with object
                            var attrFinal: Map<String, String> =
                                HashMap()// final Map<String,String>value after parsing the json and getting end result.

                            try {
                                if (it.get(i).attr is Map<*, *>) {
                                    //check if the map is a map<string,string> only ....or contains another map within ...
                                    attrFinal = it.get(i).attr as Map<String, String>

//                                Log.d("Attr", attrFinal.toString())


                                } else if (it.get(i).attr is ArrayList<*>) {
                                    //if the attr i a list that contains a map than again contains various maps...
                                    var list = it.get(i).attr as ArrayList<*>

                                    for (i in 0 until list.size) {
                                        attrInsideList = list.get(i) as Map<String, String>
                                        if (attrInsideList.containsKey(livedataSetsList.get(j).label)) {
                                            attrFinal = attrInsideList
                                            break
                                        }
                                    }
                                }
                            } catch (e: Exception) {
                                Log.d("Exception", e.printStackTrace().toString())
                            }


                            if (attrFinal.get(livedataSetsList.get(j).label) != null) {

                                val currentString =
                                    it.get(i).dTime
                                val separated = currentString?.split(".")?.toTypedArray()
                                var label = getDate(separated?.get(0)!!)

                                if (!xAxisLabel.contains(label)) {
                                    xAxisLabel.add(label)
//                                    Log.d("Date ::$i", label)
                                }

                                var value =
                                    (attrFinal.get(livedataSetsList.get(j).label)).toString()
                                value = value?.replace(",", "")

                                livedataSetsList.get(j).addEntry(
                                    Entry(
                                        (livedataSetsList.get(j).values.size + 1).toFloat(),
                                        value!!.toFloat()
                                    )
                                )
                            } else if (livedataSetsList.get(j).label.contains(".")) {

                                try {
                                    //if we need to get values of nested values of attributes within a sensor
                                    // fetch with below logic from object then get map within from i
                                    //
                                    val separated1 =
                                        livedataSetsList.get(j).label.split(".").toTypedArray()

//                                    Log.d("separated",separated1.toString())
                                    if (attrFinal.get(separated1[0]) != null) {
                                        attrSub =
                                            attrFinal.get(separated1[0]) as Map<String, String>
                                        if (attrSub.get(separated1[1]) != null) {

                                            attrFinal = attrSub

                                            val currentString =
                                                it.get(i).dTime
                                            val separated =
                                                currentString?.split(".")?.toTypedArray()

                                            var label = getDate(separated?.get(0)!!)

                                            if (!xAxisLabel.contains(label)) {
                                                xAxisLabel.add(label)
//                                            Log.d("Date ::$i", label)
                                            }

                                            var value = (attrFinal.get(separated1[1])).toString()
                                            value = value.replace(",", "")

                                            livedataSetsList.get(j).addEntry(
                                                Entry(
                                                    (livedataSetsList.get(j).values.size + 1).toFloat(),
                                                    value!!.toFloat()
                                                )
                                            )

                                        }

                                    }
                                } catch (e: Exception) {

                                }


                            }

                        }
                    }

                    //update the graph with linedatasets filled values and notify the graph adapter
                    if (livedataSetsList.size > 0) {
                        lineChart.xAxis.valueFormatter = IndexAxisValueFormatter(xAxisLabel)
                        lineChart.xAxis.labelCount = xAxisLabel.size

                        livedataSets3List = ArrayList()
                        livedataSets3List.addAll(livedataSetsList)
                        for (i in 0 until livedataSets3List.size) {
                            Log.d(
                                livedataSets3List.get(i).label.toString(),
                                livedataSets3List.get(i).values.size.toString()
                            )
                        }

                        livedataSets3List.removeIf { x -> x.values.size == 0 }

                        for (i in 0 until livedataSetsList.size) {
                            for (j in 0 until legendList.size) {
                                if (livedataSetsList.get(i).label.equals(legendList.get(j).name)) {
                                    legendList.get(j).valuesSize =
                                        livedataSetsList.get(i).values.size
                                }
                            }

                        }
                        legendList.removeIf { x -> x.valuesSize == 0 }
                        legendAdapter.notifyDataSetChanged()
                        livedataSetsList.clear()
                        livedataSetsList.addAll(livedataSets3List)

                        val data = LineData(livedataSetsList as List<ILineDataSet>?)
                        data.setDrawValues(true)
                        lineChart.clear()
                        lineChart.data = data
                        lineChart.setVisibleXRangeMaximum(4F);
                        lineChart.moveViewToX(livedataSetsList.get(0).values.size.toFloat())
                        lineChart.notifyDataSetChanged()
                    } else {
                        mBinding.cvLegend.visibility = View.GONE
                        mBinding.tvHistory?.visibility = View.GONE
                        mBinding.btnLandscape?.visibility = View.GONE
                    }

                } else {
                    mBinding.cvLegend.visibility = View.GONE
                    mBinding.tvHistory?.visibility = View.GONE
                    mBinding.btnLandscape?.visibility = View.GONE
                }

            } catch (e: Exception) {
                Log.d("exception", e.printStackTrace().toString())
            }


        })

    }

    @RequiresApi(Build.VERSION_CODES.N)
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)


        lineChart = mBinding.root.findViewById(R.id.chartBar)
        initGraph()
        setAdapter()

        mBinding.btnLandscape?.setOnClickListener(View.OnClickListener {
            deviceDetailActivity.changeOrientation()

        })

        mBinding.ivClose.setOnClickListener(View.OnClickListener {
            baseActivity?.onBackPressed()
        })
    }

    //set adapter for all check list of sensor list
    private fun setAdapter() {

        try {
            legendList = ArrayList()
            legendAdapter = LegendAdapter(legendList)
            mBinding.rvLegend.layoutManager = LinearLayoutManager(requireContext())
            legendAdapter.setOnViewClickListener(object : LegendAdapter.OnViewClickListener {
                override fun onItemClick(position: Int) {
                    try {
                        if (legendList.size > 0) {

                            if (legendList.get(position).isCheck) {
                                legendList.get(position).isCheck = false
                            } else {
                                legendList.get(position).isCheck = true
                            }


                            livedataSets2List.clear()
                            for (i in 0 until legendList.size) {
                                for (j in 0 until livedataSetsList.size) {

                                    if ((legendList.get(i).name.equals(
                                            livedataSetsList.get(j).label,
                                            true
                                        )) && legendList.get(
                                            i
                                        ).isCheck
                                    ) {
                                        livedataSets2List.add(livedataSetsList.get(j))
                                    }

                                }
                            }


                            if (livedataSets2List.size > 0) {
                                lineChart.clear()
                                lineChart.notifyDataSetChanged()
                                val data = LineData(livedataSets2List as List<ILineDataSet>?)
                                data.setDrawValues(true)
                                lineChart.data = data
                                lineChart.setVisibleXRangeMaximum(4F);
                                lineChart.moveViewToX(livedataSets2List.get(0).values.size.toFloat())
                                lineChart.notifyDataSetChanged()
                            } else {
                                lineChart.clear()
                                lineChart.notifyDataSetChanged()
                            }
                            legendAdapter.notifyDataSetChanged()
//                            mBinding.nsvMain!!.scrollBy(
//                                mBinding.nsvMain!!.scrollX,
//                                mBinding.nsvMain!!.scrollY
//                            )

                        }
                    } catch (e: Exception) {

                    }


                }
            })
            mBinding.rvLegend.adapter = legendAdapter
        } catch (e: Exception) {

        }
    }

    //initialize graph with all the needed properties...
    private fun initGraph() {
        lineChart.description.isEnabled = false
        lineChart.isDragEnabled = true
        lineChart.setScaleEnabled(true)
        lineChart.setPinchZoom(true)
        lineChart.enableScroll()
        lineChart.isDoubleTapToZoomEnabled = true
        lineChart.setDrawBorders(false)
        lineChart.setDrawGridBackground(false)
        lineChart.setBackgroundColor(ContextCompat.getColor(requireContext(), R.color.white))
        lineChart.isScrollContainer = true
        lineChart.isHorizontalScrollBarEnabled = true

        lineChart.xAxis.labelRotationAngle = 0F

        lineChart.xAxis.position = XAxis.XAxisPosition.BOTTOM
        lineChart.xAxis.isGranularityEnabled = false
        lineChart.xAxis.granularity = 2.0F
        lineChart.xAxis.setAvoidFirstLastClipping(false)
        lineChart.xAxis.setDrawLimitLinesBehindData(false)
        lineChart.axisRight.isEnabled = true
        lineChart.legend.isEnabled = false
        lineChart.legend.form = Legend.LegendForm.SQUARE
        lineChart.legend.formSize = 9f
        lineChart.legend.textSize = resources.getDimension(R.dimen._3ssp)
        lineChart.legend.textColor = ContextCompat.getColor(requireContext(), R.color.black)
        lineChart.legend.horizontalAlignment = Legend.LegendHorizontalAlignment.CENTER
        lineChart.legend.verticalAlignment = Legend.LegendVerticalAlignment.BOTTOM
        lineChart.legend.orientation = Legend.LegendOrientation.HORIZONTAL
        lineChart.legend.xEntrySpace = 5f
        lineChart.legend.yOffset = 20f
        lineChart.legend.setDrawInside(false)

        val xAxis: XAxis = lineChart.xAxis
        xAxis.position = XAxis.XAxisPosition.BOTTOM
        xAxis.setDrawGridLines(true)
        xAxis.granularity = 1f // only intervals of 1 day

        lineChart.axisRight.isEnabled = false

    }

    //check datatype format that is allowed for livedata graph sensor history data display.
    fun checkDataType(dataType: String): Boolean {
        if ((dataType.equals(AppConstants.sensorDataTypeNumber, true)) ||
            (dataType.equals(AppConstants.sensorDataTypeInteger, true)) ||
            (dataType.equals(AppConstants.sensorDataTypeDecimal, true)) ||
            (dataType.equals(AppConstants.sensorDataTypeLong, true)) ||
            (dataType.equals(AppConstants.sensorDataTypeBIT, true)) ||
            (dataType.equals(AppConstants.sensorDataTypeOBJECT, true))
        ) {
            return true
        } else {
            return false
        }
    }

    //on resume
    override fun onResume() {
        super.onResume()
        requireActivity().registerReceiver(
            mMessageReceiver,
            IntentFilter(AppConstants.INTENT_REFRESH_HISTORY)
        )
    }

    override fun onPause() {
        super.onPause()
        requireActivity().unregisterReceiver(mMessageReceiver);
    }


    override fun onClick(v: View?) {
    }

    override fun onDestroy() {
        super.onDestroy()
    }

    override fun onConfigurationChanged(newConfig: Configuration) {
        super.onConfigurationChanged(newConfig)
        try {
            val displayMetrics = DisplayMetrics()
            baseActivity?.windowManager?.defaultDisplay?.getMetrics(displayMetrics)

            var width = displayMetrics.widthPixels
            var height = displayMetrics.heightPixels
            Log.d("TAG", "width " + width)
            Log.d("TAG", "height " + height)
            var height2: Int = height - (height / 2).toInt()
            Log.d("TAG", "height " + height2)

            val currentOrientation = resources.configuration.orientation
            if (currentOrientation == Configuration.ORIENTATION_LANDSCAPE) {
                Log.v("TAG", "Landscape !!!")
                val params = LinearLayout.LayoutParams(
                    LinearLayout.LayoutParams.MATCH_PARENT,
                    LinearLayout.LayoutParams.MATCH_PARENT
                )

                params.height = height2
                lineChart.layoutParams = params


            } else {
                Log.v("TAG", "Portrait !!!")

                val params = LinearLayout.LayoutParams(
                    LinearLayout.LayoutParams.MATCH_PARENT,
                    LinearLayout.LayoutParams.MATCH_PARENT
                )
                params.height = height / 2
                lineChart.layoutParams = params


            }
        } catch (e: Exception) {

        }
    }


}
