package com.avnet.ebv.view.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import com.avnet.ebv.R
import com.avnet.ebv.ViewModelFactory
import com.avnet.ebv.base.BaseFragment
import com.avnet.ebv.common.SharedPref
import com.avnet.ebv.data.remote.ApiConstant
import com.avnet.ebv.databinding.FragmentUserSettingBinding
import com.avnet.ebv.model.response.UserIdentityResponse
import com.avnet.ebv.view.activity.MainActivity
import com.avnet.ebv.viewmodel.UserSettingViewModel
import com.google.gson.GsonBuilder
import javax.inject.Inject


class UserSettingFragment : BaseFragment() {
    private lateinit var mBinding: FragmentUserSettingBinding

    @Inject
    lateinit var userSettingViewModel: UserSettingViewModel

    @Inject
    lateinit var viewModelFactory: ViewModelFactory

    companion object {
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View {
        mBinding = FragmentUserSettingBinding.inflate(layoutInflater)
        return mBinding.root
    }

    override fun initViewModel() {

        userSettingViewModel = viewModelFactory.create(UserSettingViewModel::class.java)
        mBinding.lifecycleOwner = this
    }

    override fun observeViewModel() {

    }

    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        clicks()
    }

    override fun onResume() {
        super.onResume()
        (activity as MainActivity).tvTitle?.text = getString(R.string.user_setting)
        (activity as MainActivity).btnAddDevice?.visibility = View.INVISIBLE


        var userDetails = GsonBuilder().create().fromJson(
            SharedPref.instance!!.getValueFromPreferences(getString(R.string.pref_user_details)),
            UserIdentityResponse::class.java
        )

        mBinding.txtUserLogin.text = userDetails.data!!.userId.toString()
        mBinding.txtCpid.text = userDetails.data!!.cpId.toString()
        mBinding.txtBackendUrl.text = ApiConstant.BASE_URL_USER2
        mBinding.txtAppVersionUrl.text = requireContext().packageManager.getPackageInfo(
            requireContext().packageName,
            0
        ).versionName+" (" +requireContext().packageManager.getPackageInfo(
            requireContext().packageName,
            0
        ).versionCode.toString() +")"

        mBinding.txtRootUserLogin.text=SharedPref.instance!!.getValueFromPreferences(getString(R.string.pref_root_user_email))

    }

    private fun clicks() {

    }


}